package o3;
import java.util.*;
import java.io.*;

public class ClangEmit {
  PrintWriter pr = null;
  public ClangEmit(String fname) {
    try {
      pr = new PrintWriter(new FileWriter(fname)); init();
    } catch(Exception ex) {
      System.err.printf("cannot open output file '%s'.\n", fname);
      System.exit(1);
    }
  }
  public void close() { pr.close(); }
  public void put(String s) { pr.println(s); }
  private void init() {
    String[] a = {
    "#include <stdio.h>",
    "#include <stdlib.h>",
    "#include <string.h>",
    "#define nil 0",
    "typedef void *ptr;",
    "typedef ptr (*func)();",
    "typedef struct vtbl_r {",
    "  char *name;",
    "  int bcnt, acnt;",
    "  func *funcs;",
    "} vtbl_r, *vtbl_p;",
    "typedef struct obj_r {",
    "  vtbl_r *ops;",
    "} obj_r, *obj_p;", };
    for(String s: a) { pr.println(s); }
    for(int i = 0; i < 5; ++i) {
      pr.printf("obj_p send%d(obj_p self, char *name", i);
      for(int j = 0; j < i; ++j) { pr.printf(", ptr a%d", j); }
      pr.println(") {");
      pr.println("  for(int i = 0; self->ops[i].name != 0; ++i) {");
      pr.println("    if(strcmp(name, self->ops[i].name) == 0) {");
      pr.println("      vtbl_p p = self->ops+i;");
      pr.println("      int bc = p->bcnt, ac = p->acnt;");
      pr.println("      for(int k = 0; k < bc; ++k)");
      pr.print(  "        ((func)(p->funcs[k]))(self");
      for(int j = 0; j < i; ++j) { pr.printf(", a%d", j); }
      pr.println(");");
      pr.print(  "      ptr ret = ((func)(p->funcs[bc]))(self");
      for(int j = 0; j < i; ++j) { pr.printf(", a%d", j); }
      pr.println(");");
      pr.println("      for(int k = 0; k < ac; ++k)");
      pr.print(  "        ((func)(p->funcs[bc+k+1]))(self");
      for(int j = 0; j < i; ++j) { pr.printf(", a%d", j); }
      pr.println(");");
      pr.println("      return ret;");
      pr.println("    }");
      pr.println("  }");
      pr.println("  fprintf(stderr, \"%s not sent.\\n\", name); exit(1);");
      pr.println("}");
    }
    for(int i = 0; i < 5; ++i) {
      pr.printf("obj_p call%d(vtbl_p p", i);
      for(int j = 0; j < i; ++j) { pr.printf(", ptr a%d", j); }
      pr.println(") {");
      pr.println("  int bc = p->bcnt, ac = p->acnt;");
      pr.println("  for(int k = 0; k < bc; ++k)");
      pr.print(  "    ((func)(p->funcs[k]))(");
      for(int j = 0; j < i; ++j) { pr.printf("%sa%d", (j>0?", ":""), j); }
      pr.println(");");
      pr.print(  "  ptr ret = ((func)(p->funcs[bc]))(");
      for(int j = 0; j < i; ++j) { pr.printf("%sa%d", (j>0?", ":""), j); }
      pr.println(");");
      pr.println("  for(int k = 0; k < ac; ++k)");
      pr.print(  "    ((func)(p->funcs[bc+k+1]))(");
      for(int j = 0; j < i; ++j) { pr.printf("%sa%d", (j>0?", ":""), j); }
      pr.println(");");
      pr.println("  return ret;");
      pr.println("}");
    }
    for(int i = 0; i < 5; ++i) {
      pr.printf("obj_p callx%d(vtbl_p p", i);
      for(int j = 0; j < i; ++j) { pr.printf(", ptr a%d", j); }
      pr.println(") {");
      pr.println("  int bc = p->bcnt, ac = p->acnt;");
      pr.println("  for(int k = 0; k < bc; ++k)");
      pr.print(  "    ((func)(p->funcs[k]))(");
      for(int j = 0; j < i; ++j) { pr.printf("%sa%d", (j>0?", ":""), j); }
      pr.println(");");
      pr.print(  "  ptr ret = ((func)(p->funcs[bc]))(");
      for(int j = 0; j < i; ++j) { pr.printf("%sa%d", (j>0?", ":""), j); }
      pr.println(");");
      pr.println("  for(int k = 0; k < ac; ++k)");
      pr.print(  "    ((func)(p->funcs[bc+k+1]))(ret");
      for(int j = 0; j < i; ++j) { pr.printf("%sa%d", ", ", j); }
      pr.println(");");
      pr.println("  return ret;");
      pr.println("}");
    }
  }
}
