package o3;
import java.util.*;

public class Tbody {
  public static abstract class Base {
    int lineno = 0, tid = -1, npara = 0;
    Tree.Para[] paras;
    int[] args = {};
    String idn = "?", cname = "?";
    TypeName tname = null;
    Annots annot;
    TypeEquate te = null;
    TreeMap<String,Proctype> pdic = null;
    TreeMap<String,Integer> pnum = null;
    public String getIdn() { return idn; }
    public String getCname() { return cname; }
    public TypeName getTypename() { return tname; }
    public int getNpara() { return npara; }
    public void setTid(int i, String c, TypeName n){tid=i;cname=c;tname=n;}
    public int getTid() { return tid; }
    public void setArgs(int[] a) { args = a; }
    public int[] getArgs() { return args; }
    public Tree.Para[] getParas() { return paras; }
    public boolean isGen() { return npara != args.length; }
    public boolean eqlArgs(int[] tids) {
      if(args.length != tids.length) { return false; }
      for(int i = 0; i < args.length; ++i) {
        if(args[i] != tids[i]) { return false; }
      }
      return true;
    }
    public abstract Base clone();
    public abstract void mkPdic(TypeEnv te);
    public Set<String> getPnames() { return pdic.keySet(); }
    public Proctype getProc(String idn) { return  pdic.get(idn); }
    public void addProc(String i, Proctype p) { pdic.put(i, p); }
    public int getPnum(String idn) {
      if(pnum == null) {
        pnum = new TreeMap<String,Integer>();
        int n = 0;
        for(String s: pdic.keySet()) { pnum.put(s, n++); }
      }
      return pnum.get(idn);
    }
    public void show(int i) { System.out.println(nsp(i)+toString()); }
    public String toString() { return "?"; }
  }
  public static class Mclu extends Base {
    boolean proc = false;
    Mtree.Base[] body;
    VarEnv ve = new VarEnv();
    public Mclu(int l, String i, Annots a, Tree.Para[] q,
                Mtree.Base[] b, boolean p) {
      lineno=l; idn=i; annot=a; paras=q; npara=q.length; body=b; proc=p;
    }
    public boolean isProc() { return proc; }
    public Base clone() {
      return new Mclu(lineno, idn, annot, paras, body, proc);
    }
    public void mkPdic(TypeEnv tenv) {
      te = new TypeEquate(tenv); te.add1("selftype", tid);
      pdic = new TreeMap<String,Proctype>();
    }
    public void exec() {
      Mtree.TpEquate tp = new Mtree.TpEquate(te);
      for(Mtree.Base m: body) { m.exec(tp); }
    }
    public void callProc(TypeEnv tenv, Tree.Para[] para, int[] args) {
      TypeEquate te1 = new TypeEquate(tenv); te1.add(para, args);
      Mtree.TpEquate tp1 = new Mtree.TpEquate(te1);
      for(Mtree.Base m: body) { m.exec(tp1); }
    }
    public void check1() {
      String q = String.format("%d: $%s$", lineno, cname);
      for(String s: pdic.keySet()) { pdic.get(s).collectVar(q+s, ve); }
    }
    public void show(int i) {
      System.out.println(nsp(i)+idn+pstr(paras)+":"+proc);
      System.out.println(nsp(i+1)+ve.toString());
      annot.show(i+1);
      for(Mtree.Base m: body) { m.show(i+1); }
      if(pdic == null) { return; }
      for(String key: pdic.keySet()) { 
        System.out.printf("%s[%s]\n", nsp(i), key);
        pdic.get(key).show(i+1);
      }
    }
    public void cemit_dcl1(ClangEmit cle) {
      String pfx = String.format("%s_%d", idn, tid);
      cle.put(String.format("typedef struct %s_r *%s_p;", pfx, pfx));
      cle.put(String.format("extern vtbl_r %s_vtbl[];", pfx));
    }
    public void cemit_dcl2(ClangEmit cle) {
      String pfx = String.format("%s_%d", idn, tid);
      cle.put(String.format("typedef struct %s_r {", pfx));
      cle.put("  vtbl_r *ops;");
      for(String v: ve) {
        if(ve.getPosition(v) < 0) {
//        String s = te.tid2sname(te.tname2tid(ve.getTypename(v)));
          cle.put(String.format("  obj_p %s;", v));
        }
      }
      cle.put(String.format("} %s_r;", pfx));
      for(String i: pdic.keySet()) {
        pdic.get(i).cemit_dcl(cle, tid, pfx, i);
      }
    }
    public void cemit_body(ClangEmit cle) {
      String pfx = String.format("%s_%d", idn, tid);
      for(String i: pdic.keySet()) {
        String fns = "";
        Proctype q = pdic.get(i);
        List<Proctype> bf = q.getBodyBefore(), af = q.getBodyAfter();
        for(int k = bf.size()-1; k >= 0; --k) {
          Proctype r = bf.get(k);
          r.cemit_body(cle, tid, pfx, i+"_B"+k, r.getBody().getVarEnv());
          fns += ",\n (func)"+pfx+"_"+i+"_B"+k;
        }
        q.cemit_body(cle, tid, pfx, i, q.getBody().getVarEnv());
        fns += ",\n (func)"+pfx+"_"+i;
        for(int k = 0; k < af.size(); ++k) {
          Proctype r = af.get(k);
          r.cemit_body(cle, tid, pfx, i+"_A"+k, r.getBody().getVarEnv());
          fns += ",\n (func)"+pfx+"_"+i+"_A"+k;
        }
        cle.put(String.format("func %s_%s_funcs[] = {%s };",
                              pfx, i, fns.substring(2)));
      }
      cle.put(String.format("vtbl_r %s_vtbl[] = {", pfx));
      for(String i: pdic.keySet()) {
        Proctype q = pdic.get(i);
        int a1 = q.getBodyAfter().size(), b1 = q.getBodyBefore().size();
        cle.put(String.format(" {\"%s\",%d,%d,%s_%s_funcs},",i,b1,a1,pfx,i));
      }
      cle.put(" {0,0,0,0}");
      cle.put("};");
      StrList list = annot.get("@clangemit2");
      if(list == null) { return; }
      for(String s: list) {
        if(s.charAt(0) == '"') { cle.put(unesc(s)); }
      }
    }
  }
  public static class Clus extends Base {
    Tree.Vdef[] vdefs;
    Tree.Proc[] pdefs;
    boolean itf = false;
    VarEnv ve = new VarEnv();
    public Clus(int l, String i, Annots a, Tree.Para[] q,
                Tree.Vdef[] v, Tree.Proc[] p,boolean b) {
      lineno=l; idn=i; annot=a; paras=q; vdefs=v; pdefs=p; itf=b;
      npara = q.length;
    }
    public Clus clone() {
      return new Clus(lineno, idn, annot, paras, vdefs, pdefs, itf);
    }
    public boolean isItf() { return itf; }
    public Tree.Vdef[] getVdefs() { return vdefs; }
    public Tree.Proc[] getPdefs() { return pdefs; }
    public void mkPdic(TypeEnv tenv) {
      te = new TypeEquate(tenv);
      if(args.length > 0) { te.add(paras, args); }
      pdic = new TreeMap<String,Proctype>();
      for(Tree.Proc p: pdefs) {
        Tree.Para[] a = p.getParas();
        int [] b = new int[a.length];
        for(int i = 0; i < a.length; ++i) {
	  b[i] = te.tname2tid(a[i].getTypename());
          if(b[i] < 0) {
            System.err.printf("%d: undef type: %s\n",
                              p.getLineno(), a[i].toString());
            b[i] = TypeEnv.NONE;
          }
	}
        int r = (p.getRtype()==null) ? -1 : te.tname2tid(p.getRtype());
        Proctype q = new Proctype(te, b, r, p);
        if(p.getIdn().equals("create")) { q.putVdefs(vdefs); }
        q.modRecv(tid, tid); pdic.put(p.getIdn(), q);
      }
    }
    public void show(int i) {
      System.out.println(nsp(i)+idn+pstr(paras)+":"+itf);
      System.out.println(nsp(i+1)+ve.toString());
      annot.show(i+1);
      for(Tree.Base t: vdefs) { t.show(i+1); }
      if(pdic == null) { return; }
      for(String key: pdic.keySet()) { pdic.get(key).show(i+1); }
    }
    public void check1() {
      for(Tree.Vdef v: vdefs) { ve.add(v.getName(),v.getTypename(),-1); }
      for(Tree.Proc p: pdefs) { p.check1(te, ve, tname); }
    }
    public void check2() {
      Tree.Typecheck tc = new Tree.Typecheck(te, ve);
      for(Tree.Vdef v: vdefs) {
        te.tname2tid(v.getTypename());
        if(v.getExpr() != null) { v.getExpr().accept(tc); }
      }
      for(Tree.Proc p: pdefs) {
        p.accept(new Tree.Typecheck(te, p.getVarEnv()));
      }
    }
    public void cemit_gendcl(ClangEmit cle) {
      StrList list = annot.get("@clangemitgendcl");
      if(list == null) { return; }
      for(String s: list) {
        if(s.charAt(0) == '"') {
          String t = unesc(s);
          cle.put(String.format(t, tid, tid, tid, tid));
        }
      }
    }
    public void cemit_dcl1(ClangEmit cle) {
      StrList list = annot.get("@clangemit");
      String pfx = String.format("%s_%d", idn, tid);
      if(list != null) {
        for(String s: list) {
          if(s.charAt(0) == '"') {
            String t = unesc(s);
            if(t.indexOf("%s") >= 0) {
              cle.put(String.format(t, pfx, pfx, pfx, pfx));
            } else {
              cle.put(String.format(t, tid, tid, tid, tid));
            }
          }
        }
      }
      if(annot.get("@clangnofwdcl") != null) { return ; }
      if(itf) { 
        cle.put(String.format("obj_p %s_p;", pfx));
      } else {
        cle.put(String.format("typedef struct %s_r *%s_p;", pfx, pfx));
        cle.put(String.format("extern vtbl_r %s_vtbl[];", pfx));
      }
    }
    public void cemit_dcl2(ClangEmit cle) {
      if(annot.get("@clangnofwdcl") != null) { return ; }
      String pfx = String.format("%s_%d", idn, tid);
      if(annot.get("@clangnoemit") == null) {
        cle.put(String.format("typedef struct %s_r {", pfx));
	cle.put("  vtbl_r *ops;");
	for(String v: ve) {
	  if(ve.getPosition(v) < 0) {
//          String s = te.tid2sname(te.tname2tid(ve.getTypename(v)));
	    cle.put(String.format("  obj_p %s;", v));
	  }
	}
	cle.put(String.format("} %s_r;", pfx));
      }
      for(Tree.Proc p: pdefs) {
        String i = p.getIdn(); pdic.get(i).cemit_dcl(cle, tid, pfx, i);
      }
    }
    public void cemit_body(ClangEmit cle) {
      String pfx = String.format("%s_%d", idn, tid);
      for(Tree.Proc p: pdefs) {
        String i = p.getIdn(), fn = pfx+"_"+i;
        Proctype q = pdic.get(i);
        q.cemit_body(cle, tid, pfx, i, q.getBody().getVarEnv());
        cle.put(String.format("func %s_funcs[] = { (func)%s };", fn, fn));
      }
      cle.put(String.format("vtbl_r %s_vtbl[] = {", pfx));
      for(String i: pdic.keySet()) {
        cle.put(String.format(" {\"%s\",0,0,%s_%s_funcs},", i, pfx, i));
      }
      cle.put(" {0,0,0,0}");
      cle.put("};");
      StrList list = annot.get("@clangemit2");
      if(list == null) { return; }
      for(String s: list) {
        if(s.charAt(0) == '"') { cle.put(unesc(s)); }
      }
    }
  }
  private static String pstr(Tree.Para[] paras) {
    String p = "";
    if(paras.length > 0) {
      p = "[" + paras[0];
      for(int k = 1; k < paras.length; ++k) { p += "," + paras[k]; }
      p += "]";
    }
    return p;
  }
  private static String nsp(int i) {
    String s = ""; while(s.length() < i) { s+=" "; } return s;
  }
  private static String unesc(String s) {
    s = s.substring(1, s.length()-1);
    int len = s.length();
    StringBuilder b = new StringBuilder();
    for(int i = 0; i < len; ++i) {
      if(s.charAt(i) != '\\') {
        b.append(s.charAt(i));
      } else if(i+1 < len) {
        b.append(s.charAt(++i));
      }
    }
    return b.toString();
  }
}
