package o3;
import o3.analysis.*;
import o3.node.*;
import o3.TreeList;
import java.util.*;

class Traverser extends DepthFirstAdapter {
  TypeEnv tenv;
  ClangEmit cle;
  public Traverser(TypeEnv e, ClangEmit c) { tenv = e; cle = c; }
  @Override
  public void outAEmpAnnot(AEmpAnnot n) {
    setOut(n, new Annots());
  }
  @Override
  public void outAOneAnnot(AOneAnnot n) {
    StrList x = new StrList(n.getAtidn().getText());
    Annots a = (Annots)getOut(n.getAnnot()); a.add(x); setOut(n, a);
  }
  @Override
  public void outALis1Annot(ALis1Annot n) {
    StrList x = (StrList)getOut(n.getNlist());
    x.prepend(n.getAtidn().getText());
    Annots a = (Annots)getOut(n.getAnnot()); a.add(x); setOut(n, a);
  }
  @Override
  public void outALis2Annot(ALis2Annot n) {
    StrList x = (StrList)getOut(n.getNlist());
    x.prepend(n.getAtidn().getText());
    Annots a = (Annots)getOut(n.getAnnot()); a.add(x); setOut(n, a);
  }
  @Override
  public void outAEmpNlist(AEmpNlist n) { setOut(n, new StrList()); }
  @Override
  public void outAOneNlist(AOneNlist n) {
    StrList x = (StrList)getOut(n.getNlist());
    x.add((String)getOut(n.getNent())); setOut(n, x);
  }
  @Override
  public void outAIdnNent(AIdnNent n) {setOut(n,n.getIdent().getText());}
  @Override
  public void outAIntNent(AIntNent n) {setOut(n,n.getIconst().getText());}
  @Override
  public void outAStrNent(AStrNent n) {setOut(n,n.getString().getText());}
  @Override
  public void outACluMclu(ACluMclu n) {
    Tbody.Mclu c = new Tbody.Mclu(n.getIdent().getLine(),
      n.getIdent().getText(), (Annots)getOut(n.getAnnot()),
      ((TreeList)getOut(n.getCpara())).getParas(),
      ((MtreeList)getOut(n.getMstats())).getArray(), false);
    tenv.addBody(c);
  }
  @Override
  public void outAPrcMclu(APrcMclu n) {
    Tbody.Mclu c = new Tbody.Mclu(n.getIdent().getLine(),
      n.getIdent().getText(), (Annots)getOut(n.getAnnot()),
      ((TreeList)getOut(n.getCpara())).getParas(),
      ((MtreeList)getOut(n.getMstats())).getArray(), true);
    tenv.addBody(c);
  }
  @Override
  public void outAEmpMstats(AEmpMstats n) {
    setOut(n, new MtreeList());
  }
  @Override
  public void outAOneMstats(AOneMstats n) {
    MtreeList l = (MtreeList)getOut(n.getMstats());
    l.add((Mtree.Base)getOut(n.getMstat())); setOut(n, l);
  }
  @Override
  public void outACallMstat(ACallMstat n) {
    setOut(n, getOut(n.getMcall()));
  }
  @Override
  public void outAForMstat(AForMstat n) {
    setOut(n, new Mtree.For(n.getFor().getLine(), n.getIdent().getText(),
      (Mtree.Mexp)getOut(n.getMexp()),
      ((MtreeList)getOut(n.getMstats())).getArray()));
  }
  @Override
  public void inAIfstMstat(AIfstMstat n) {
    MtreeList l = new MtreeList(); setIn(n, l); setIn(n.getMelif(), l);
  }
  @Override
  public void outAIfstMstat(AIfstMstat n) {
    MtreeList l = (MtreeList)getIn(n);
    l.prepend(new Mtree.Then(n.getIf().getLine(),
      (Mtree.Mexp)getOut(n.getMexp()),
      ((MtreeList)getOut(n.getMstats())).getArray()));
    setOut(n, new Mtree.Ifst(n.getIf().getLine(), l.getArray()));
  }
  @Override
  public void outAElseMelif(AElseMelif n) {
    ((MtreeList)getIn(n)).add(
      new Mtree.Else(n.getElse().getLine(),
        ((MtreeList)getOut(n.getMstats())).getArray()));
  }
  @Override
  public void inAMoreMelif(AMoreMelif n) {
    setIn(n.getMelif(), getIn(n));
  }
  @Override
  public void outAMoreMelif(AMoreMelif n) {
    ((MtreeList)getIn(n)).prepend(
      new Mtree.Then(n.getThen().getLine(),
        (Mtree.Mexp)getOut(n.getMexp()),
	((MtreeList)getOut(n.getMstats())).getArray()));
  }
  @Override
  public void outACallMexp(ACallMexp n) {
    setOut(n, getOut(n.getMcall()));
  }
  @Override
  public void outATypeMexp(ATypeMexp n) {
    setOut(n, new Mtree.Mtype(0, (TypeName)getOut(n.getTname())));
  }
  @Override
  public void outAProcMexp(AProcMexp n) {
    setOut(n, new Mtree.Mproc(n.getLeft().getLine(),
      (TypeName)getOut(n.getTname()), n.getIdent().getText()));
  }
  @Override
  public void outASconstMexp(ASconstMexp n) {
    setOut(n, new Mtree.Mstr(n.getString().getLine(),
                             n.getString().getText()));
  }
  @Override
  public void outANoneMcall(ANoneMcall n) {
    setOut(n, new Mtree.Mcall(n.getBang().getLine(),
      (Mtree.Mexp)getOut(n.getMexp()),
      n.getIdent().getText(), new Mtree.Mexp[]{}));
  }
  @Override
  public void outAArgsMcall(AArgsMcall n) {
    setOut(n, new Mtree.Mcall(n.getBang().getLine(),
      (Mtree.Mexp)getOut(n.getMexp()),
      n.getIdent().getText(),
      ((MtreeList)getOut(n.getMargs())).getEarray()));
  }
  @Override
  public void outAOneMargs(AOneMargs n) {
    MtreeList l = new MtreeList();
    l.add((Mtree.Mexp)getOut(n.getMexp())); setOut(n, l);
  }
  @Override
  public void outATwoMargs(ATwoMargs n) {
    MtreeList l = (MtreeList)getOut(n.getMargs());
    l.add((Mtree.Mexp)getOut(n.getMexp())); setOut(n, l);
  }
  @Override
  public void outACluClus(ACluClus n) {
    Tbody.Clus c = new Tbody.Clus(
      n.getIdent().getLine(), n.getIdent().getText(),
      (Annots)getOut(n.getAnnot()),
      ((TreeList)getOut(n.getCpara())).getParas(),
      ((TreeList)getOut(n.getVdefs())).getVdefs(),
      ((TreeList)getOut(n.getPdefs())).getProcs(), false);
    tenv.addBody(c);
  }
  @Override
  public void outAItfClus(AItfClus n) {
    Tbody.Clus c = new Tbody.Clus(
      n.getIdent().getLine(), n.getIdent().getText(),
      (Annots)getOut(n.getAnnot()),
      ((TreeList)getOut(n.getCpara())).getParas(),
      ((TreeList)getOut(n.getVdefs())).getVdefs(),
      ((TreeList)getOut(n.getPdefs())).getProcs(), true);
    tenv.addBody(c);
  }
  @Override
  public void outAEmpCpara(AEmpCpara n) {
    setOut(n, new TreeList());
  }
  @Override
  public void outAOneCpara(AOneCpara n) {
    setOut(n, getOut(n.getPlist()));
  }
  @Override
  public void outAEmpVdefs(AEmpVdefs n) {
    setOut(n, new TreeList());
  }
  @Override
  public void outAOneVdefs(AOneVdefs n) {
    setOut(n, ((TreeList)getOut(n.getVdefs())).add(ngo(n.getVdef())));
  }
  @Override
  public void outAInitVdef(AInitVdef n) {
    setOut(n, new Tree.Vdef(
      n.getIdent().getLine(), n.getIdent().getText(),
      (TypeName)getOut(n.getTname()), xgo(n.getExpr())));
  }
  @Override
  public void outADeclVdef(ADeclVdef n) {
    setOut(n, new Tree.Vdef(
      n.getIdent().getLine(), n.getIdent().getText(),
      (TypeName)getOut(n.getTname())));
  }
  @Override
  public void outAEmpPdefs(AEmpPdefs n) {
    setOut(n, new TreeList());
  }
  @Override
  public void outAOnePdefs(AOnePdefs n) {
    setOut(n, ((TreeList)getOut(n.getPdefs())).add(ngo(n.getPdef())));
  }
  @Override
  public void outAFuncPdef(AFuncPdef n) {
    setOut(n, new Tree.Proc(
      n.getIdent().getLine(), n.getIdent().getText(),
      (Annots)getOut(n.getAnnot()),
      ((TreeList)getOut(n.getFbody())).getArray(),
      ((TreeList)getOut(n.getParms())).getParas(),
      (TypeName)getOut(n.getTname())));
  }
  @Override
  public void outAVoidPdef(AVoidPdef n) {
    setOut(n, new Tree.Proc(
      n.getIdent().getLine(), n.getIdent().getText(),
      (Annots)getOut(n.getAnnot()),
      ((TreeList)getOut(n.getVbody())).getArray(),
      ((TreeList)getOut(n.getParms())).getParas()));
  }
  @Override
  public void outAEmpParms(AEmpParms n) {
    setOut(n, new TreeList());
  }
  @Override
  public void outAListParms(AListParms n) {
    setOut(n, (TreeList)getOut(n.getPlist()));
  }
  @Override
  public void outAOnePlist(AOnePlist n) {
    setOut(n, new TreeList(ngo(n.getParm())));
  }
  @Override
  public void outAManyPlist(AManyPlist n) {
    setOut(n, ((TreeList)getOut(n.getPlist())).add(ngo(n.getParm())));
  }
  @Override
  public void outAOneParm(AOneParm n) {
    setOut(n, new Tree.Para(
      n.getIdent().getLine(), n.getIdent().getText(),
      (TypeName)getOut(n.getTname())));
  }
  @Override
  public void outAOneTname(AOneTname n) {
    setOut(n, new TypeName(n.getIdent().getText()));
  }
  @Override
  public void outAParaTname(AParaTname n) {
    setOut(n, new TypeName(n.getIdent().getText(),
               ((TnameList)getOut(n.getTlist())).getArray()));
  }
  @Override
  public void outAOneTlist(AOneTlist  n) {
    TnameList list = new TnameList();
    list.add((TypeName)(getOut(n.getTname()))); setOut(n, list);
  }
  @Override
  public void outAManyTlist(AManyTlist n) {
    TnameList list = (TnameList)(getOut(n.getTlist()));
    list.add((TypeName)(getOut(n.getTname()))); setOut(n, list);
  }
  @Override
  public void outAEmpFbody(AEmpFbody n) {
    setOut(n, new TreeList());
  }
  @Override
  public void outAOneFbody(AOneFbody n) {
    TreeList t = (TreeList)getOut(n.getFbody()); t.add(ngo(n.getFstmt()));
    setOut(n, t);
  }
  @Override
  public void outAEmpVbody(AEmpVbody n) {
    setOut(n, new TreeList());
  }
  @Override
  public void outAOneVbody(AOneVbody n) {
    TreeList t = (TreeList)getOut(n.getVbody()); t.add(ngo(n.getVstmt()));
    setOut(n, t);
  }
  @Override
  public void outAAscalFstmt(AAscalFstmt n) {
    setOut(n, ngo(n.getAscal()));
  }
  @Override
  public void outARetnFstmt(ARetnFstmt n) {
    setOut(n, new Tree.Retn(n.getReturn().getLine(), xgo(n.getExpr())));
  }
  @Override
  public void outAWhstFstmt(AWhstFstmt n) {
    setOut(n, new Tree.Whst(
      n.getWhile().getLine(), xgo(n.getExpr()), ago(n.getFbody())));
  }
  @Override
  public void inAIfstFstmt(AIfstFstmt n) {
    TreeList l = new TreeList(); setIn(n, l); setIn(n.getFelif(), l);
  }
  @Override
  public void outAIfstFstmt(AIfstFstmt n) {
    TreeList l = (TreeList)getIn(n);
    l.prepend(new Tree.Then(n.getIf().getLine(),
      xgo(n.getExpr()), ago(n.getFbody())));
    setOut(n, new Tree.Ifst(n.getIf().getLine(), l.getArray()));
  }
  @Override
  public void outAElseFelif(AElseFelif n) {
    ((TreeList)getIn(n)).add(
      new Tree.Else(n.getElse().getLine(), ago(n.getFbody())));
  }
  @Override
  public void inAMoreFelif(AMoreFelif n) {
    setIn(n.getFelif(), getIn(n));
  }
  @Override
  public void outAMoreFelif(AMoreFelif n) {
    ((TreeList)getIn(n)).prepend(
      new Tree.Then(n.getThen().getLine(), 
        xgo(n.getExpr()), ago(n.getFbody())));
  }
  @Override
  public void outAAscalVstmt(AAscalVstmt n) {
    setOut(n, ngo(n.getAscal()));
  }
  @Override
  public void outARetnVstmt(ARetnVstmt n) {
    setOut(n, new Tree.Retn(n.getReturn().getLine(), null));
  }
  @Override
  public void outAWhstVstmt(AWhstVstmt n) {
    setOut(n, new Tree.Whst(
      n.getWhile().getLine(), xgo(n.getExpr()), ago(n.getVbody())));
  }
  @Override
  public void inAIfstVstmt(AIfstVstmt n) {
    TreeList l = new TreeList(); setIn(n, l); setIn(n.getVelif(), l);
  }
  @Override
  public void outAIfstVstmt(AIfstVstmt n) {
    TreeList l = (TreeList)getIn(n);
    l.prepend(new Tree.Then(n.getIf().getLine(),
      xgo(n.getExpr()), ago(n.getVbody())));
    setOut(n, new Tree.Ifst(n.getIf().getLine(), l.getArray()));
  }
  @Override
  public void outAElseVelif(AElseVelif n) {
    ((TreeList)getIn(n)).add(
      new Tree.Else(n.getElse().getLine(), ago(n.getVbody())));
  }
  @Override
  public void inAMoreVelif(AMoreVelif n) {
    setIn(n.getVelif(), getIn(n));
  }
  @Override
  public void outAMoreVelif(AMoreVelif n) {
    ((TreeList)getIn(n)).prepend(
      new Tree.Then(n.getElsif().getLine(),
        xgo(n.getExpr()), ago(n.getVbody())));
  }
  @Override
  public void outAVdefAscal(AVdefAscal n) {
    setOut(n, getOut(n.getVdef()));
  }
  @Override
  public void outAAssignAscal(AAssignAscal n) {
    setOut(n, new Tree.Assign(
      n.getIdent().getLine(), n.getIdent().getText(), ngo(n.getExpr())));
  }
  @Override
  public void outAAstoreAscal(AAstoreAscal n) {
    setOut(n, new Tree.Call(
      n.getAssign().getLine(),
      ngo(n.getPmmex()), "store",
      ngo(n.getIdx()), ngo(n.getExpr())));
  }
  @Override
  public void outAPstoreAscal(APstoreAscal n) {
    setOut(n, new Tree.Call(n.getIdent().getLine(),
      ngo(n.getPmmex()), ("get_"+n.getIdent().getText()), ngo(n.getExpr())));
  }
  @Override
  public void outACallAscal(ACallAscal n) {
    setOut(n, ngo(n.getPclex()));
  }
  @Override
  public void outAOrexpExpr(AOrexpExpr n) {
    setOut(n, ngo(n.getOrexp()));
  }  
  @Override
  public void outAAndexOrexp(AAndexOrexp n) {
    setOut(n, ngo(n.getAndex()));
  }
  @Override
  public void outACorOrexp(ACorOrexp n) {
    setOut(n, new Tree.Cor(
      n.getCor().getLine(), ngo(n.getOrexp()), ngo(n.getAndex())));
  }
  @Override
  public void outARelexAndex(ARelexAndex n) {
    setOut(n, ngo(n.getRelex()));
  }
  @Override
  public void outACandAndex(ACandAndex n) {
    setOut(n, new Tree.Cand(
      n.getCand().getLine(), ngo(n.getAndex()), ngo(n.getRelex())));
  }
  @Override
  public void outAAddexRelex(AAddexRelex n) {
    setOut(n, ngo(n.getAddex()));
  }
  @Override
  public void outAEqlRelex(AEqlRelex n) {
    setOut(n, new Tree.Call(n.getEql().getLine(),
      ngo(n.getLeft()), "equal", ngo(n.getRight())));
  }
  @Override
  public void outANoteqRelex(ANoteqRelex n) {
    setOut(n, new Tree.Not(n.getNoteq().getLine(),
      new Tree.Call(n.getNoteq().getLine(),
        ngo(n.getLeft()), "equal", ngo(n.getRight()))));
  }
  @Override
  public void outALtRelex(ALtRelex n) {
    setOut(n, new Tree.Call(n.getLt().getLine(),
      ngo(n.getLeft()), "lt", ngo(n.getRight())));
  }
  @Override
  public void outAGtRelex(AGtRelex n) {
    setOut(n, new Tree.Call(n.getGt().getLine(),
      ngo(n.getLeft()), "gt", ngo(n.getRight())));
  }
  @Override
  public void outALeRelex(ALeRelex n) {
    setOut(n, new Tree.Call(n.getLe().getLine(),
      ngo(n.getLeft()), "le", ngo(n.getRight())));
  }
  @Override
  public void outAGeRelex(AGeRelex n) {
    setOut(n, new Tree.Call(n.getGe().getLine(),
      ngo(n.getLeft()), "ge", ngo(n.getRight())));
  }
  @Override
  public void outAMulexAddex(AMulexAddex n) {
    setOut(n, ngo(n.getMulex()));
  }
  @Override
  public void outAAddAddex(AAddAddex n) {
    setOut(n, new Tree.Call(n.getPlus().getLine(),
      ngo(n.getAddex()), "add", ngo(n.getMulex())));
  }
  @Override
  public void outASubAddex(ASubAddex n) {
    setOut(n, new Tree.Call(n.getMinus().getLine(),
      ngo(n.getAddex()), "sub", ngo(n.getMulex())));
  }
  @Override
  public void outAUexprMulex(AUexprMulex n) {
    setOut(n, ngo(n.getUexpr()));
  }
  @Override
  public void outAMulMulex(AMulMulex n) {
    setOut(n, new Tree.Call(n.getMult().getLine(),
      ngo(n.getMulex()), "mul", ngo(n.getUexpr())));
  }
  @Override
  public void outADivMulex(ADivMulex n) {
    setOut(n, new Tree.Call(n.getDiv().getLine(),
      ngo(n.getMulex()), "div", ngo(n.getUexpr())));
  }
  @Override
  public void outARemMulex(ARemMulex n) {
    setOut(n, new Tree.Call(n.getRem().getLine(),
      ngo(n.getMulex()), "mod", ngo(n.getUexpr())));
  }
  @Override
  public void outACalexUexpr(ACalexUexpr n) {
    setOut(n, ngo(n.getCalex()));
  }
  @Override
  public void outAMemexUexpr(AMemexUexpr n) {
    setOut(n, ngo(n.getMemex()));
  }
  @Override
  public void outAMinusUexpr(AMinusUexpr n) {
    setOut(n, new Tree.Call(n.getMinus().getLine(),
      ngo(n.getCalex()), "minus"));
  }
  @Override
  public void outAPlusUexpr(APlusUexpr n) {
    setOut(n, new Tree.Call(n.getPlus().getLine(),
      ngo(n.getCalex()), "plus"));
  }
  @Override
  public void outABangUexpr(ABangUexpr n) {
    setOut(n, new Tree.Not(n.getBang().getLine(), ngo(n.getCalex())));
  }
  @Override
  public void outAEmptyArgs(AEmptyArgs n) {
    setOut(n, new TreeList());
  }
  @Override
  public void outAListArgs(AListArgs n) {
    setOut(n, getOut(n.getAlist()));
  }
  @Override
  public void outAOneAlist(AOneAlist n) {
    setOut(n, new TreeList(ngo(n.getExpr())));
  }
  @Override
  public void outAListAlist(AListAlist n) {
    TreeList list = (TreeList)getOut(n.getAlist());
    list.add(ngo(n.getExpr())); setOut(n, list);
  }
  @Override
  public void outATypeCalex(ATypeCalex n) {
    setOut(n, new Tree.Tcall(n.getIdent().getLine(),
      ((TypeName)getOut(n.getTname())),
      n.getIdent().getText(), ego(n.getArgs())));
  }
  @Override
  public void outAMemexCalex(AMemexCalex n) {
    setOut(n, new Tree.Call(n.getIdent().getLine(),
      ngo(n.getMemex()), n.getIdent().getText(), ego(n.getArgs())));
  }
  @Override
  public void outACascCalex(ACascCalex n) {
    setOut(n, new Tree.Call(n.getIdent().getLine(),
      ngo(n.getCalex()), n.getIdent().getText(), ego(n.getArgs())));
  }
  @Override
  public void outAPropCalex(APropCalex n) {
    setOut(n, new Tree.Call(n.getIdent().getLine(),
      ngo(n.getCalex()), ("get_"+n.getIdent().getText())));
  }
  @Override
  public void outAArrayCalex(AArrayCalex n) {
    setOut(n, new Tree.Call(n.getKagi().getLine(),
      ngo(n.getCalex()), "fetch", ngo(n.getExpr())));
  }
  @Override
  public void outAIdentMemex(AIdentMemex n) {
    setOut(n, new Tree.Ident(n.getIdent().getLine(),
      n.getIdent().getText()));
  }
  @Override
  public void outAConstMemex(AConstMemex n) {
    setOut(n, ngo(n.getConst()));
  }
  @Override
  public void outAPropMemex(APropMemex n) {
    setOut(n, new Tree.Call(n.getIdent().getLine(),
      ngo(n.getMemex()), ("get_"+n.getIdent().getText())));
  }
  @Override
  public void outAArrayMemex(AArrayMemex n) {
    setOut(n, new Tree.Call(n.getKagi().getLine(),
      ngo(n.getMemex()), "fetch", ngo(n.getExpr())));
  }
  @Override
  public void outAParenMemex(AParenMemex n) {
    setOut(n, ngo(n.getExpr()));
  }
  @Override
  public void outATypePclex(ATypePclex n) {
    setOut(n, new Tree.Tcall(n.getIdent().getLine(),
      ((TypeName)getOut(n.getTname())),
      n.getIdent().getText(), ego(n.getArgs())));
  }
  @Override
  public void outACallPclex(ACallPclex n) {
    setOut(n, new Tree.Call(n.getIdent().getLine(),
      ngo(n.getPmmex()), n.getIdent().getText(), ego(n.getArgs())));
  }
  @Override
  public void outACascPclex(ACascPclex n) {
    setOut(n, new Tree.Call(n.getIdent().getLine(),
      ngo(n.getPclex()), n.getIdent().getText(), ego(n.getArgs())));
  }
  @Override
  public void outAIdentPmmex(AIdentPmmex n) {
    setOut(n, new Tree.Ident(n.getIdent().getLine(),
      n.getIdent().getText()));
  }
  @Override
  public void outAConstPmmex(AConstPmmex n) {
    setOut(n, ngo(n.getConst()));
  }
  @Override
  public void outAPropPmmex(APropPmmex n) {
    setOut(n, new Tree.Call(n.getIdent().getLine(),
      ngo(n.getPmmex()), ("get_"+n.getIdent().getText()).intern()));
  }
  @Override
  public void outAArrayPmmex(AArrayPmmex n) {
    setOut(n, new Tree.Call(n.getKagi().getLine(),
      ngo(n.getPmmex()), "fetch", ngo(n.getExpr())));
  }
  @Override
  public void outAIconstConst(AIconstConst n) {
    setOut(n, new Tree.Iconst(
      n.getIconst().getLine(), new Integer(n.getIconst().getText())));
  }
  @Override
  public void outASconstConst(ASconstConst n) {
    setOut(n, new Tree.Sconst(
      n.getString().getLine(), n.getString().getText()));
  }
  @Override
  public void outAFalseConst(AFalseConst n) {
    setOut(n, new Tree.Bconst(n.getFalse().getLine(), false));
  }
  @Override
  public void outATrueConst(ATrueConst n) {
    setOut(n, new Tree.Bconst(n.getTrue().getLine(), true));
  }
  @Override
  public void outANilConst(ANilConst n) {
    setOut(n, new Tree.Nil(n.getNil().getLine()));
  }
  private Tree.Base ngo(Node n) { return (Tree.Base)(getOut(n)); }
  private Tree.Expr xgo(Node n) { return (Tree.Expr)(getOut(n)); }
  private Tree.Base[] ago(Node n) {return ((TreeList)getOut(n)).getArray();}
  private Tree.Expr[] ego(Node n) {return ((TreeList)getOut(n)).getEArray();}
}
