package o3;
import java.util.*;

public class TypeEnv {
  public static final int NONE=0, ANY=1, BOOL=2, INT=3, STRING=4, ARRAY=5;
  private String[] predef = {"none","any", "bool","int","string", "array"};
  List<Tbody.Base> tbs = new ArrayList<Tbody.Base>();
  List<SortedSet<Integer>> sup = new ArrayList<SortedSet<Integer>>();
  public void addBody(Tbody.Base b) {
    int tid = tbs.size(); tbs.add(b);
    sup.add(new TreeSet<Integer>()); sup.get(sup.size()-1).add(ANY);
    if(tbs.size() == predef.length) {
      for(int i = 0; i < tbs.size(); ++i) {
        if(!tbs.get(i).getIdn().equals(predef[i])) {
	  throw new RuntimeException("panic: id wrong on: "+predef[i]);
	}
      }
    }
    String s = b.getIdn() + "_" + tid;
    if(b.getNpara() > 0) {
      b.setTid(tid, s+"[]", null);
    } else {
      b.setTid(tid, s, new TypeName(b.getIdn()));
    }
  }
  public int idn2tgen(String idn, int[] tids, TypeName n) {
    for(int i = tbs.size()-1; i >= 0; --i) {
      Tbody.Base b = tbs.get(i);
      if(b.getIdn().equals(idn) && b.eqlArgs(tids)) { return i; }
    }
    for(int i = tbs.size()-1; i >= 0; --i) {
      Tbody.Base b = tbs.get(i);
      if(b.getIdn().equals(idn) && b.getNpara() == tids.length) { //TODO:cmpt
        int tid = tbs.size();
	b = b.clone(); b.setArgs(tids); tbs.add(b);
        sup.add(new TreeSet<Integer>()); sup.get(sup.size()-1).add(ANY);
        String s = b.getIdn()+"_"+i+"[";
	for(int j = 0; j < tids.length; ++j) {
	  s += tbs.get(tids[j]).getCname() + ((j < tids.length-1)?",":"]");
	}
	b.setTid(tid, s, n); b.mkPdic(this); return tid;
      }
    }
    return NONE;
  }
  public Tbody.Base tid2tbody(int i) {
    if(i < 0 || i >= tbs.size()) { return null; }
    return tbs.get(i);
  }
  public int lookMproc(String s) {
    for(int i = tbs.size()-1; i >= 0; --i) {
      if(tbs.get(i).getIdn().equals(s)) { return i; }
    }
    return -1;
  }
  public SortedSet<Integer> tid2sup(int i) { return sup.get(i); }
  public void addSup(int i, int j) {
    if(i == j || sup.get(i).contains(j)) { return; }
    sup.get(i).add(j);
    for(Integer k: sup.get(j)) { addSup(i, k); }
  }
  public boolean isSup(int i, int j) { return sup.get(i).contains(j); }
  public int idn2tid(String idn) {
    for(int i = tbs.size()-1; i >= 0; --i) {
      Tbody.Base b = tbs.get(i);
      if(b.getNpara() == 0 && b.getIdn().equals(idn)) { return i; }
    }
    return -1;
  }
  public String tid2cname(int tid) {
    if(tid < 0) { return "unknown"; }
    return tbs.get(tid).getCname();
  }
  public String tid2sname(int tid) { return tbs.get(tid).getIdn()+"_"+tid; }  
  public void check(boolean dump) {
    for(int i = 0; i < tbs.size(); ++i) {
      Tbody.Base b = tbs.get(i);
      if(!b.isGen()) { b.mkPdic(this); }
    }
    for(int i = 0; i < tbs.size(); ++i) {
      Tbody.Base b = tbs.get(i);
      if(dump) { System.out.println(b.getCname() + ": " + i); }
      if(b.isGen()) {
        if(b instanceof Tbody.Mclu && dump) { b.show(1); }
      } else if(b instanceof Tbody.Clus) {
        Tbody.Clus c = (Tbody.Clus)b; c.check1(); c.check2();
        if(dump) { showSup(i); c.show(1); }
      } else if(b instanceof Tbody.Mclu) {
        Tbody.Mclu m = (Tbody.Mclu)b;
        m.exec(); m.check1();
        if(dump) { showSup(i); b.show(1); }
      }
    }
  }  
  public void showSup(int i) {
    System.out.print(" super:");
    for(Integer k: sup.get(i)) { System.out.printf(" %d", k); }
    System.out.println();
  }
  public void cemit(ClangEmit cle) {
    for(int i = 0; i < tbs.size(); ++i) {
      Tbody.Base b = tbs.get(i);
      if(b instanceof Tbody.Clus) {
        Tbody.Clus c = (Tbody.Clus)b;
        if(b.isGen()) { c.cemit_gendcl(cle); } else { c.cemit_dcl1(cle); }
      } else if(b instanceof Tbody.Mclu) {
        Tbody.Mclu m = (Tbody.Mclu)b;
        if(!m.isGen()) { m.cemit_dcl1(cle); }
      }
    }
    cle.put("/* declaration1 end */");
    for(int i = 0; i < tbs.size(); ++i) {
      Tbody.Base b = tbs.get(i);
      if(b instanceof Tbody.Clus) {
        Tbody.Clus c = (Tbody.Clus)b;
        if(!b.isGen()) { c.cemit_dcl2(cle); }
      } else if(b instanceof Tbody.Mclu) {
        Tbody.Mclu m = (Tbody.Mclu)b;
        if(!m.isGen()) { m.cemit_dcl2(cle); }
      }
    }
    cle.put("/* declaration2 end */");
    for(int i = 0; i < tbs.size(); ++i) {
      Tbody.Base b = tbs.get(i);
      if(b instanceof Tbody.Clus) {
        Tbody.Clus c = (Tbody.Clus)b;
        if(!c.isItf() && !b.isGen()) { c.cemit_body(cle); }
      } else if(b instanceof Tbody.Mclu) {
        Tbody.Mclu m = (Tbody.Mclu)b;
        if(!m.isProc() && !m.isGen()) { m.cemit_body(cle); }
      }
    }
  }
}
