package o3;
import java.util.*;

public class VarEnv implements Iterable<String> {
  List<String> names = new ArrayList<String>();
  List<TypeName> types = new ArrayList<TypeName>();
  List<Integer> pos = new ArrayList<Integer>();
  public void add(String v, TypeName t, int p) {
    names.add(v.intern()); types.add(t); pos.add(p);
  }
  public VarEnv copy() {
    VarEnv ve = new VarEnv();
    for(int i = 0; i < names.size(); ++i) {
      ve.add(names.get(i), types.get(i), pos.get(i));
    }
    return ve;
  }
  public void moveToParam(String s, int p) {
    for(int i = 0; i < names.size(); ++i) {
      if(names.get(i).equals(s)) { pos.set(i, p); }
      else if(pos.get(i) >= p) { pos.set(i, pos.get(i) + 1); }
    }
  }
  public String toString() {
    String s = "(";
    boolean para = true;
    for(int i = 0; i < names.size(); ++i) {
      if(pos.get(i) < 0 && para) {
        if(s.charAt(s.length()-1) == ',') {s=s.substring(0,s.length()-1);}
        s += ")["; para = false;
      }
      s += names.get(i) + ((pos.get(i)<-1)?"*:":":") + types.get(i) + ",";
    }
    if(s.charAt(s.length()-1) == ',') { s = s.substring(0, s.length()-1); }
    s += para ? ")" : "]"; return s;
  }
  public TypeName getTypename(String v) {
    int i = names.indexOf(v); return (i < 0) ? TypeName.UNDEF : types.get(i);
  }
  public int getPosition(String v) {
    int i = names.indexOf(v); return (i < 0) ? -1 : pos.get(i);
  }
  public boolean hasName(String v) { return names.indexOf(v) >= 0; }
  public void copyTo(VarEnv e) {
    for(int i = 0; i < names.size(); ++i) {
      e.add(names.get(i), types.get(i), pos.get(i));
    }
  }
  public Iterator<String> iterator() { return names.iterator(); }
}
