/* This file was generated by SableCC (http://www.sablecc.org/). */

package o3.parser;

import o3.lexer.*;
import o3.node.*;
import o3.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

@SuppressWarnings("nls")
public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected ArrayList nodeList;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    public Parser(@SuppressWarnings("hiding") Lexer lexer)
    {
        this.lexer = lexer;
    }

    protected void filter() throws ParserException, LexerException, IOException
    {
        // Empty body
    }

    private void push(int numstate, ArrayList listNode, boolean hidden) throws ParserException, LexerException, IOException
    {
        this.nodeList = listNode;

        if(!hidden)
        {
            filter();
        }

        if(!this.stack.hasNext())
        {
            this.stack.add(new State(numstate, this.nodeList));
            return;
        }

        State s = (State) this.stack.next();
        s.state = numstate;
        s.nodes = this.nodeList;
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private int state()
    {
        State s = (State) this.stack.previous();
        this.stack.next();
        return s.state;
    }

    private ArrayList pop()
    {
        return ((State) this.stack.previous()).nodes;
    }

    private int index(Switchable token)
    {
        this.converter.index = -1;
        token.apply(this.converter);
        return this.converter.index;
    }

    @SuppressWarnings("unchecked")
    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, true);
        List<Node> ign = null;
        while(true)
        {
            while(index(this.lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new LinkedList<Node>();
                }

                ign.add(this.lexer.next());
            }

            if(ign != null)
            {
                this.ignoredTokens.setIn(this.lexer.peek(), ign);
                ign = null;
            }

            this.last_pos = this.lexer.peek().getPos();
            this.last_line = this.lexer.peek().getLine();
            this.last_token = this.lexer.peek();

            int index = index(this.lexer.peek());
            this.action[0] = Parser.actionTable[state()][0][1];
            this.action[1] = Parser.actionTable[state()][0][2];

            int low = 1;
            int high = Parser.actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < Parser.actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > Parser.actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    this.action[0] = Parser.actionTable[state()][middle][1];
                    this.action[1] = Parser.actionTable[state()][middle][2];
                    break;
                }
            }

            switch(this.action[0])
            {
                case SHIFT:
		    {
		        ArrayList list = new ArrayList();
		        list.add(this.lexer.next());
                        push(this.action[1], list, false);
                    }
		    break;
                case REDUCE:
                    switch(this.action[1])
                    {
                    case 0: /* reduce AEmpProg */
		    {
			ArrayList list = new0();
			push(goTo(0), list, false);
		    }
		    break;
                    case 1: /* reduce AClusProg */
		    {
			ArrayList list = new1();
			push(goTo(0), list, false);
		    }
		    break;
                    case 2: /* reduce AMclcProg */
		    {
			ArrayList list = new2();
			push(goTo(0), list, false);
		    }
		    break;
                    case 3: /* reduce AEmpAnnot */
		    {
			ArrayList list = new3();
			push(goTo(1), list, false);
		    }
		    break;
                    case 4: /* reduce AOneAnnot */
		    {
			ArrayList list = new4();
			push(goTo(1), list, false);
		    }
		    break;
                    case 5: /* reduce ALis1Annot */
		    {
			ArrayList list = new5();
			push(goTo(1), list, false);
		    }
		    break;
                    case 6: /* reduce ALis2Annot */
		    {
			ArrayList list = new6();
			push(goTo(1), list, false);
		    }
		    break;
                    case 7: /* reduce AEmpNlist */
		    {
			ArrayList list = new7();
			push(goTo(2), list, false);
		    }
		    break;
                    case 8: /* reduce AOneNlist */
		    {
			ArrayList list = new8();
			push(goTo(2), list, false);
		    }
		    break;
                    case 9: /* reduce AIdnNent */
		    {
			ArrayList list = new9();
			push(goTo(3), list, false);
		    }
		    break;
                    case 10: /* reduce AIntNent */
		    {
			ArrayList list = new10();
			push(goTo(3), list, false);
		    }
		    break;
                    case 11: /* reduce AStrNent */
		    {
			ArrayList list = new11();
			push(goTo(3), list, false);
		    }
		    break;
                    case 12: /* reduce AEmpOptcm */
		    {
			ArrayList list = new12();
			push(goTo(4), list, false);
		    }
		    break;
                    case 13: /* reduce AOneOptcm */
		    {
			ArrayList list = new13();
			push(goTo(4), list, false);
		    }
		    break;
                    case 14: /* reduce AEmpOptsm */
		    {
			ArrayList list = new14();
			push(goTo(5), list, false);
		    }
		    break;
                    case 15: /* reduce AOneOptsm */
		    {
			ArrayList list = new15();
			push(goTo(5), list, false);
		    }
		    break;
                    case 16: /* reduce ACluMclu */
		    {
			ArrayList list = new16();
			push(goTo(6), list, false);
		    }
		    break;
                    case 17: /* reduce APrcMclu */
		    {
			ArrayList list = new17();
			push(goTo(6), list, false);
		    }
		    break;
                    case 18: /* reduce AEmpMstats */
		    {
			ArrayList list = new18();
			push(goTo(7), list, false);
		    }
		    break;
                    case 19: /* reduce AOneMstats */
		    {
			ArrayList list = new19();
			push(goTo(7), list, false);
		    }
		    break;
                    case 20: /* reduce ACallMstat */
		    {
			ArrayList list = new20();
			push(goTo(8), list, false);
		    }
		    break;
                    case 21: /* reduce AForMstat */
		    {
			ArrayList list = new21();
			push(goTo(8), list, false);
		    }
		    break;
                    case 22: /* reduce AIfstMstat */
		    {
			ArrayList list = new22();
			push(goTo(8), list, false);
		    }
		    break;
                    case 23: /* reduce ANoneMelif */
		    {
			ArrayList list = new23();
			push(goTo(9), list, false);
		    }
		    break;
                    case 24: /* reduce AElseMelif */
		    {
			ArrayList list = new24();
			push(goTo(9), list, false);
		    }
		    break;
                    case 25: /* reduce AMoreMelif */
		    {
			ArrayList list = new25();
			push(goTo(9), list, false);
		    }
		    break;
                    case 26: /* reduce ACallMexp */
		    {
			ArrayList list = new26();
			push(goTo(10), list, false);
		    }
		    break;
                    case 27: /* reduce ATypeMexp */
		    {
			ArrayList list = new27();
			push(goTo(10), list, false);
		    }
		    break;
                    case 28: /* reduce AProcMexp */
		    {
			ArrayList list = new28();
			push(goTo(10), list, false);
		    }
		    break;
                    case 29: /* reduce ASconstMexp */
		    {
			ArrayList list = new29();
			push(goTo(10), list, false);
		    }
		    break;
                    case 30: /* reduce ANoneMcall */
		    {
			ArrayList list = new30();
			push(goTo(11), list, false);
		    }
		    break;
                    case 31: /* reduce AArgsMcall */
		    {
			ArrayList list = new31();
			push(goTo(11), list, false);
		    }
		    break;
                    case 32: /* reduce AOneMargs */
		    {
			ArrayList list = new32();
			push(goTo(12), list, false);
		    }
		    break;
                    case 33: /* reduce ATwoMargs */
		    {
			ArrayList list = new33();
			push(goTo(12), list, false);
		    }
		    break;
                    case 34: /* reduce ACluClus */
		    {
			ArrayList list = new34();
			push(goTo(13), list, false);
		    }
		    break;
                    case 35: /* reduce AItfClus */
		    {
			ArrayList list = new35();
			push(goTo(13), list, false);
		    }
		    break;
                    case 36: /* reduce AEmpCpara */
		    {
			ArrayList list = new36();
			push(goTo(14), list, false);
		    }
		    break;
                    case 37: /* reduce AOneCpara */
		    {
			ArrayList list = new37();
			push(goTo(14), list, false);
		    }
		    break;
                    case 38: /* reduce AEmpVdefs */
		    {
			ArrayList list = new38();
			push(goTo(15), list, false);
		    }
		    break;
                    case 39: /* reduce AOneVdefs */
		    {
			ArrayList list = new39();
			push(goTo(15), list, false);
		    }
		    break;
                    case 40: /* reduce AInitVdef */
		    {
			ArrayList list = new40();
			push(goTo(16), list, false);
		    }
		    break;
                    case 41: /* reduce ADeclVdef */
		    {
			ArrayList list = new41();
			push(goTo(16), list, false);
		    }
		    break;
                    case 42: /* reduce AEmpPdefs */
		    {
			ArrayList list = new42();
			push(goTo(17), list, false);
		    }
		    break;
                    case 43: /* reduce AOnePdefs */
		    {
			ArrayList list = new43();
			push(goTo(17), list, false);
		    }
		    break;
                    case 44: /* reduce AFuncPdef */
		    {
			ArrayList list = new44();
			push(goTo(18), list, false);
		    }
		    break;
                    case 45: /* reduce AVoidPdef */
		    {
			ArrayList list = new45();
			push(goTo(18), list, false);
		    }
		    break;
                    case 46: /* reduce AEmpParms */
		    {
			ArrayList list = new46();
			push(goTo(19), list, false);
		    }
		    break;
                    case 47: /* reduce AListParms */
		    {
			ArrayList list = new47();
			push(goTo(19), list, false);
		    }
		    break;
                    case 48: /* reduce AOnePlist */
		    {
			ArrayList list = new48();
			push(goTo(20), list, false);
		    }
		    break;
                    case 49: /* reduce AManyPlist */
		    {
			ArrayList list = new49();
			push(goTo(20), list, false);
		    }
		    break;
                    case 50: /* reduce AOneParm */
		    {
			ArrayList list = new50();
			push(goTo(21), list, false);
		    }
		    break;
                    case 51: /* reduce AOneTname */
		    {
			ArrayList list = new51();
			push(goTo(22), list, false);
		    }
		    break;
                    case 52: /* reduce AParaTname */
		    {
			ArrayList list = new52();
			push(goTo(22), list, false);
		    }
		    break;
                    case 53: /* reduce AOneTlist */
		    {
			ArrayList list = new53();
			push(goTo(23), list, false);
		    }
		    break;
                    case 54: /* reduce AManyTlist */
		    {
			ArrayList list = new54();
			push(goTo(23), list, false);
		    }
		    break;
                    case 55: /* reduce AEmpFbody */
		    {
			ArrayList list = new55();
			push(goTo(24), list, false);
		    }
		    break;
                    case 56: /* reduce AOneFbody */
		    {
			ArrayList list = new56();
			push(goTo(24), list, false);
		    }
		    break;
                    case 57: /* reduce AEmpVbody */
		    {
			ArrayList list = new57();
			push(goTo(25), list, false);
		    }
		    break;
                    case 58: /* reduce AOneVbody */
		    {
			ArrayList list = new58();
			push(goTo(25), list, false);
		    }
		    break;
                    case 59: /* reduce AAscalFstmt */
		    {
			ArrayList list = new59();
			push(goTo(26), list, false);
		    }
		    break;
                    case 60: /* reduce ARetnFstmt */
		    {
			ArrayList list = new60();
			push(goTo(26), list, false);
		    }
		    break;
                    case 61: /* reduce AWhstFstmt */
		    {
			ArrayList list = new61();
			push(goTo(26), list, false);
		    }
		    break;
                    case 62: /* reduce AIfstFstmt */
		    {
			ArrayList list = new62();
			push(goTo(26), list, false);
		    }
		    break;
                    case 63: /* reduce ANoneFelif */
		    {
			ArrayList list = new63();
			push(goTo(27), list, false);
		    }
		    break;
                    case 64: /* reduce AElseFelif */
		    {
			ArrayList list = new64();
			push(goTo(27), list, false);
		    }
		    break;
                    case 65: /* reduce AMoreFelif */
		    {
			ArrayList list = new65();
			push(goTo(27), list, false);
		    }
		    break;
                    case 66: /* reduce AAscalVstmt */
		    {
			ArrayList list = new66();
			push(goTo(28), list, false);
		    }
		    break;
                    case 67: /* reduce ARetnVstmt */
		    {
			ArrayList list = new67();
			push(goTo(28), list, false);
		    }
		    break;
                    case 68: /* reduce AWhstVstmt */
		    {
			ArrayList list = new68();
			push(goTo(28), list, false);
		    }
		    break;
                    case 69: /* reduce AIfstVstmt */
		    {
			ArrayList list = new69();
			push(goTo(28), list, false);
		    }
		    break;
                    case 70: /* reduce ANoneVelif */
		    {
			ArrayList list = new70();
			push(goTo(29), list, false);
		    }
		    break;
                    case 71: /* reduce AElseVelif */
		    {
			ArrayList list = new71();
			push(goTo(29), list, false);
		    }
		    break;
                    case 72: /* reduce AMoreVelif */
		    {
			ArrayList list = new72();
			push(goTo(29), list, false);
		    }
		    break;
                    case 73: /* reduce AVdefAscal */
		    {
			ArrayList list = new73();
			push(goTo(30), list, false);
		    }
		    break;
                    case 74: /* reduce AAssignAscal */
		    {
			ArrayList list = new74();
			push(goTo(30), list, false);
		    }
		    break;
                    case 75: /* reduce AAstoreAscal */
		    {
			ArrayList list = new75();
			push(goTo(30), list, false);
		    }
		    break;
                    case 76: /* reduce APstoreAscal */
		    {
			ArrayList list = new76();
			push(goTo(30), list, false);
		    }
		    break;
                    case 77: /* reduce ACallAscal */
		    {
			ArrayList list = new77();
			push(goTo(30), list, false);
		    }
		    break;
                    case 78: /* reduce AOrexpExpr */
		    {
			ArrayList list = new78();
			push(goTo(31), list, false);
		    }
		    break;
                    case 79: /* reduce AAndexOrexp */
		    {
			ArrayList list = new79();
			push(goTo(32), list, false);
		    }
		    break;
                    case 80: /* reduce ACorOrexp */
		    {
			ArrayList list = new80();
			push(goTo(32), list, false);
		    }
		    break;
                    case 81: /* reduce ARelexAndex */
		    {
			ArrayList list = new81();
			push(goTo(33), list, false);
		    }
		    break;
                    case 82: /* reduce ACandAndex */
		    {
			ArrayList list = new82();
			push(goTo(33), list, false);
		    }
		    break;
                    case 83: /* reduce AAddexRelex */
		    {
			ArrayList list = new83();
			push(goTo(34), list, false);
		    }
		    break;
                    case 84: /* reduce AEqlRelex */
		    {
			ArrayList list = new84();
			push(goTo(34), list, false);
		    }
		    break;
                    case 85: /* reduce ANoteqRelex */
		    {
			ArrayList list = new85();
			push(goTo(34), list, false);
		    }
		    break;
                    case 86: /* reduce ALtRelex */
		    {
			ArrayList list = new86();
			push(goTo(34), list, false);
		    }
		    break;
                    case 87: /* reduce AGtRelex */
		    {
			ArrayList list = new87();
			push(goTo(34), list, false);
		    }
		    break;
                    case 88: /* reduce ALeRelex */
		    {
			ArrayList list = new88();
			push(goTo(34), list, false);
		    }
		    break;
                    case 89: /* reduce AGeRelex */
		    {
			ArrayList list = new89();
			push(goTo(34), list, false);
		    }
		    break;
                    case 90: /* reduce AMulexAddex */
		    {
			ArrayList list = new90();
			push(goTo(35), list, false);
		    }
		    break;
                    case 91: /* reduce AAddAddex */
		    {
			ArrayList list = new91();
			push(goTo(35), list, false);
		    }
		    break;
                    case 92: /* reduce ASubAddex */
		    {
			ArrayList list = new92();
			push(goTo(35), list, false);
		    }
		    break;
                    case 93: /* reduce AUexprMulex */
		    {
			ArrayList list = new93();
			push(goTo(36), list, false);
		    }
		    break;
                    case 94: /* reduce AMulMulex */
		    {
			ArrayList list = new94();
			push(goTo(36), list, false);
		    }
		    break;
                    case 95: /* reduce ADivMulex */
		    {
			ArrayList list = new95();
			push(goTo(36), list, false);
		    }
		    break;
                    case 96: /* reduce ARemMulex */
		    {
			ArrayList list = new96();
			push(goTo(36), list, false);
		    }
		    break;
                    case 97: /* reduce ACalexUexpr */
		    {
			ArrayList list = new97();
			push(goTo(37), list, false);
		    }
		    break;
                    case 98: /* reduce AMemexUexpr */
		    {
			ArrayList list = new98();
			push(goTo(37), list, false);
		    }
		    break;
                    case 99: /* reduce AMinusUexpr */
		    {
			ArrayList list = new99();
			push(goTo(37), list, false);
		    }
		    break;
                    case 100: /* reduce APlusUexpr */
		    {
			ArrayList list = new100();
			push(goTo(37), list, false);
		    }
		    break;
                    case 101: /* reduce ABangUexpr */
		    {
			ArrayList list = new101();
			push(goTo(37), list, false);
		    }
		    break;
                    case 102: /* reduce AEmptyArgs */
		    {
			ArrayList list = new102();
			push(goTo(38), list, false);
		    }
		    break;
                    case 103: /* reduce AListArgs */
		    {
			ArrayList list = new103();
			push(goTo(38), list, false);
		    }
		    break;
                    case 104: /* reduce AOneAlist */
		    {
			ArrayList list = new104();
			push(goTo(39), list, false);
		    }
		    break;
                    case 105: /* reduce AListAlist */
		    {
			ArrayList list = new105();
			push(goTo(39), list, false);
		    }
		    break;
                    case 106: /* reduce ATypeCalex */
		    {
			ArrayList list = new106();
			push(goTo(40), list, false);
		    }
		    break;
                    case 107: /* reduce AMemexCalex */
		    {
			ArrayList list = new107();
			push(goTo(40), list, false);
		    }
		    break;
                    case 108: /* reduce ACascCalex */
		    {
			ArrayList list = new108();
			push(goTo(40), list, false);
		    }
		    break;
                    case 109: /* reduce APropCalex */
		    {
			ArrayList list = new109();
			push(goTo(40), list, false);
		    }
		    break;
                    case 110: /* reduce AArrayCalex */
		    {
			ArrayList list = new110();
			push(goTo(40), list, false);
		    }
		    break;
                    case 111: /* reduce AIdentMemex */
		    {
			ArrayList list = new111();
			push(goTo(41), list, false);
		    }
		    break;
                    case 112: /* reduce AConstMemex */
		    {
			ArrayList list = new112();
			push(goTo(41), list, false);
		    }
		    break;
                    case 113: /* reduce APropMemex */
		    {
			ArrayList list = new113();
			push(goTo(41), list, false);
		    }
		    break;
                    case 114: /* reduce AArrayMemex */
		    {
			ArrayList list = new114();
			push(goTo(41), list, false);
		    }
		    break;
                    case 115: /* reduce AParenMemex */
		    {
			ArrayList list = new115();
			push(goTo(41), list, false);
		    }
		    break;
                    case 116: /* reduce ATypePclex */
		    {
			ArrayList list = new116();
			push(goTo(42), list, false);
		    }
		    break;
                    case 117: /* reduce ACallPclex */
		    {
			ArrayList list = new117();
			push(goTo(42), list, false);
		    }
		    break;
                    case 118: /* reduce ACascPclex */
		    {
			ArrayList list = new118();
			push(goTo(42), list, false);
		    }
		    break;
                    case 119: /* reduce AIdentPmmex */
		    {
			ArrayList list = new119();
			push(goTo(43), list, false);
		    }
		    break;
                    case 120: /* reduce AConstPmmex */
		    {
			ArrayList list = new120();
			push(goTo(43), list, false);
		    }
		    break;
                    case 121: /* reduce APropPmmex */
		    {
			ArrayList list = new121();
			push(goTo(43), list, false);
		    }
		    break;
                    case 122: /* reduce AArrayPmmex */
		    {
			ArrayList list = new122();
			push(goTo(43), list, false);
		    }
		    break;
                    case 123: /* reduce AIconstConst */
		    {
			ArrayList list = new123();
			push(goTo(44), list, false);
		    }
		    break;
                    case 124: /* reduce ASconstConst */
		    {
			ArrayList list = new124();
			push(goTo(44), list, false);
		    }
		    break;
                    case 125: /* reduce AFalseConst */
		    {
			ArrayList list = new125();
			push(goTo(44), list, false);
		    }
		    break;
                    case 126: /* reduce ATrueConst */
		    {
			ArrayList list = new126();
			push(goTo(44), list, false);
		    }
		    break;
                    case 127: /* reduce ANilConst */
		    {
			ArrayList list = new127();
			push(goTo(44), list, false);
		    }
		    break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) this.lexer.next();
                        PProg node1 = (PProg) pop().get(0);
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(this.last_token,
                        "[" + this.last_line + "," + this.last_pos + "] " +
                        Parser.errorMessages[Parser.errors[this.action[1]]]);
            }
        }
    }



    @SuppressWarnings("unchecked")
    ArrayList new0() /* reduce AEmpProg */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PProg pprogNode1;
        {
            // Block

        pprogNode1 = new AEmpProg();
        }
	nodeList.add(pprogNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new1() /* reduce AClusProg */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PProg pprogNode1;
        {
            // Block
        PProg pprogNode2;
        PClus pclusNode3;
        pprogNode2 = (PProg)nodeArrayList1.get(0);
        pclusNode3 = (PClus)nodeArrayList2.get(0);

        pprogNode1 = new AClusProg(pprogNode2, pclusNode3);
        }
	nodeList.add(pprogNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new2() /* reduce AMclcProg */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PProg pprogNode1;
        {
            // Block
        PProg pprogNode2;
        PMclu pmcluNode3;
        pprogNode2 = (PProg)nodeArrayList1.get(0);
        pmcluNode3 = (PMclu)nodeArrayList2.get(0);

        pprogNode1 = new AMclcProg(pprogNode2, pmcluNode3);
        }
	nodeList.add(pprogNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new3() /* reduce AEmpAnnot */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PAnnot pannotNode1;
        {
            // Block

        pannotNode1 = new AEmpAnnot();
        }
	nodeList.add(pannotNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new4() /* reduce AOneAnnot */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAnnot pannotNode1;
        {
            // Block
        PAnnot pannotNode2;
        TAtidn tatidnNode3;
        POptcm poptcmNode4;
        pannotNode2 = (PAnnot)nodeArrayList1.get(0);
        tatidnNode3 = (TAtidn)nodeArrayList2.get(0);
        poptcmNode4 = (POptcm)nodeArrayList3.get(0);

        pannotNode1 = new AOneAnnot(pannotNode2, tatidnNode3, poptcmNode4);
        }
	nodeList.add(pannotNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new5() /* reduce ALis1Annot */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAnnot pannotNode1;
        {
            // Block
        PAnnot pannotNode2;
        TAtidn tatidnNode3;
        TLpar tlparNode4;
        PNlist pnlistNode5;
        TRpar trparNode6;
        POptcm poptcmNode7;
        pannotNode2 = (PAnnot)nodeArrayList1.get(0);
        tatidnNode3 = (TAtidn)nodeArrayList2.get(0);
        tlparNode4 = (TLpar)nodeArrayList3.get(0);
        pnlistNode5 = (PNlist)nodeArrayList4.get(0);
        trparNode6 = (TRpar)nodeArrayList5.get(0);
        poptcmNode7 = (POptcm)nodeArrayList6.get(0);

        pannotNode1 = new ALis1Annot(pannotNode2, tatidnNode3, tlparNode4, pnlistNode5, trparNode6, poptcmNode7);
        }
	nodeList.add(pannotNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new6() /* reduce ALis2Annot */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAnnot pannotNode1;
        {
            // Block
        PAnnot pannotNode2;
        TAtidn tatidnNode3;
        TKagi tkagiNode4;
        PNlist pnlistNode5;
        TGika tgikaNode6;
        POptcm poptcmNode7;
        pannotNode2 = (PAnnot)nodeArrayList1.get(0);
        tatidnNode3 = (TAtidn)nodeArrayList2.get(0);
        tkagiNode4 = (TKagi)nodeArrayList3.get(0);
        pnlistNode5 = (PNlist)nodeArrayList4.get(0);
        tgikaNode6 = (TGika)nodeArrayList5.get(0);
        poptcmNode7 = (POptcm)nodeArrayList6.get(0);

        pannotNode1 = new ALis2Annot(pannotNode2, tatidnNode3, tkagiNode4, pnlistNode5, tgikaNode6, poptcmNode7);
        }
	nodeList.add(pannotNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new7() /* reduce AEmpNlist */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PNlist pnlistNode1;
        {
            // Block

        pnlistNode1 = new AEmpNlist();
        }
	nodeList.add(pnlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new8() /* reduce AOneNlist */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNlist pnlistNode1;
        {
            // Block
        PNlist pnlistNode2;
        PNent pnentNode3;
        POptcm poptcmNode4;
        pnlistNode2 = (PNlist)nodeArrayList1.get(0);
        pnentNode3 = (PNent)nodeArrayList2.get(0);
        poptcmNode4 = (POptcm)nodeArrayList3.get(0);

        pnlistNode1 = new AOneNlist(pnlistNode2, pnentNode3, poptcmNode4);
        }
	nodeList.add(pnlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new9() /* reduce AIdnNent */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNent pnentNode1;
        {
            // Block
        TIdent tidentNode2;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);

        pnentNode1 = new AIdnNent(tidentNode2);
        }
	nodeList.add(pnentNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new10() /* reduce AIntNent */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNent pnentNode1;
        {
            // Block
        TIconst ticonstNode2;
        ticonstNode2 = (TIconst)nodeArrayList1.get(0);

        pnentNode1 = new AIntNent(ticonstNode2);
        }
	nodeList.add(pnentNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new11() /* reduce AStrNent */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PNent pnentNode1;
        {
            // Block
        TString tstringNode2;
        tstringNode2 = (TString)nodeArrayList1.get(0);

        pnentNode1 = new AStrNent(tstringNode2);
        }
	nodeList.add(pnentNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new12() /* reduce AEmpOptcm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        POptcm poptcmNode1;
        {
            // Block

        poptcmNode1 = new AEmpOptcm();
        }
	nodeList.add(poptcmNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new13() /* reduce AOneOptcm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        POptcm poptcmNode1;
        {
            // Block
        TComma tcommaNode2;
        tcommaNode2 = (TComma)nodeArrayList1.get(0);

        poptcmNode1 = new AOneOptcm(tcommaNode2);
        }
	nodeList.add(poptcmNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new14() /* reduce AEmpOptsm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        POptsm poptsmNode1;
        {
            // Block

        poptsmNode1 = new AEmpOptsm();
        }
	nodeList.add(poptsmNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new15() /* reduce AOneOptsm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        POptsm poptsmNode1;
        {
            // Block
        TSemi tsemiNode2;
        tsemiNode2 = (TSemi)nodeArrayList1.get(0);

        poptsmNode1 = new AOneOptsm(tsemiNode2);
        }
	nodeList.add(poptsmNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new16() /* reduce ACluMclu */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMclu pmcluNode1;
        {
            // Block
        TIdent tidentNode2;
        TEql teqlNode3;
        TMetacluster tmetaclusterNode4;
        PCpara pcparaNode5;
        PAnnot pannotNode6;
        PMstats pmstatsNode7;
        TEnd tendNode8;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);
        teqlNode3 = (TEql)nodeArrayList2.get(0);
        tmetaclusterNode4 = (TMetacluster)nodeArrayList3.get(0);
        pcparaNode5 = (PCpara)nodeArrayList4.get(0);
        pannotNode6 = (PAnnot)nodeArrayList5.get(0);
        pmstatsNode7 = (PMstats)nodeArrayList6.get(0);
        tendNode8 = (TEnd)nodeArrayList7.get(0);

        pmcluNode1 = new ACluMclu(tidentNode2, teqlNode3, tmetaclusterNode4, pcparaNode5, pannotNode6, pmstatsNode7, tendNode8);
        }
	nodeList.add(pmcluNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new17() /* reduce APrcMclu */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMclu pmcluNode1;
        {
            // Block
        TIdent tidentNode2;
        TEql teqlNode3;
        TMetaproc tmetaprocNode4;
        PCpara pcparaNode5;
        PAnnot pannotNode6;
        PMstats pmstatsNode7;
        TEnd tendNode8;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);
        teqlNode3 = (TEql)nodeArrayList2.get(0);
        tmetaprocNode4 = (TMetaproc)nodeArrayList3.get(0);
        pcparaNode5 = (PCpara)nodeArrayList4.get(0);
        pannotNode6 = (PAnnot)nodeArrayList5.get(0);
        pmstatsNode7 = (PMstats)nodeArrayList6.get(0);
        tendNode8 = (TEnd)nodeArrayList7.get(0);

        pmcluNode1 = new APrcMclu(tidentNode2, teqlNode3, tmetaprocNode4, pcparaNode5, pannotNode6, pmstatsNode7, tendNode8);
        }
	nodeList.add(pmcluNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new18() /* reduce AEmpMstats */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PMstats pmstatsNode1;
        {
            // Block

        pmstatsNode1 = new AEmpMstats();
        }
	nodeList.add(pmstatsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new19() /* reduce AOneMstats */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMstats pmstatsNode1;
        {
            // Block
        PMstats pmstatsNode2;
        PMstat pmstatNode3;
        pmstatsNode2 = (PMstats)nodeArrayList1.get(0);
        pmstatNode3 = (PMstat)nodeArrayList2.get(0);

        pmstatsNode1 = new AOneMstats(pmstatsNode2, pmstatNode3);
        }
	nodeList.add(pmstatsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new20() /* reduce ACallMstat */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMstat pmstatNode1;
        {
            // Block
        PMcall pmcallNode2;
        POptsm poptsmNode3;
        pmcallNode2 = (PMcall)nodeArrayList1.get(0);
        poptsmNode3 = (POptsm)nodeArrayList2.get(0);

        pmstatNode1 = new ACallMstat(pmcallNode2, poptsmNode3);
        }
	nodeList.add(pmstatNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new21() /* reduce AForMstat */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList8 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMstat pmstatNode1;
        {
            // Block
        TFor tforNode2;
        TIdent tidentNode3;
        TColon tcolonNode4;
        PMexp pmexpNode5;
        TDo tdoNode6;
        PMstats pmstatsNode7;
        TEnd tendNode8;
        POptsm poptsmNode9;
        tforNode2 = (TFor)nodeArrayList1.get(0);
        tidentNode3 = (TIdent)nodeArrayList2.get(0);
        tcolonNode4 = (TColon)nodeArrayList3.get(0);
        pmexpNode5 = (PMexp)nodeArrayList4.get(0);
        tdoNode6 = (TDo)nodeArrayList5.get(0);
        pmstatsNode7 = (PMstats)nodeArrayList6.get(0);
        tendNode8 = (TEnd)nodeArrayList7.get(0);
        poptsmNode9 = (POptsm)nodeArrayList8.get(0);

        pmstatNode1 = new AForMstat(tforNode2, tidentNode3, tcolonNode4, pmexpNode5, tdoNode6, pmstatsNode7, tendNode8, poptsmNode9);
        }
	nodeList.add(pmstatNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new22() /* reduce AIfstMstat */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMstat pmstatNode1;
        {
            // Block
        TIf tifNode2;
        PMexp pmexpNode3;
        TThen tthenNode4;
        PMstats pmstatsNode5;
        PMelif pmelifNode6;
        TEnd tendNode7;
        POptsm poptsmNode8;
        tifNode2 = (TIf)nodeArrayList1.get(0);
        pmexpNode3 = (PMexp)nodeArrayList2.get(0);
        tthenNode4 = (TThen)nodeArrayList3.get(0);
        pmstatsNode5 = (PMstats)nodeArrayList4.get(0);
        pmelifNode6 = (PMelif)nodeArrayList5.get(0);
        tendNode7 = (TEnd)nodeArrayList6.get(0);
        poptsmNode8 = (POptsm)nodeArrayList7.get(0);

        pmstatNode1 = new AIfstMstat(tifNode2, pmexpNode3, tthenNode4, pmstatsNode5, pmelifNode6, tendNode7, poptsmNode8);
        }
	nodeList.add(pmstatNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new23() /* reduce ANoneMelif */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PMelif pmelifNode1;
        {
            // Block

        pmelifNode1 = new ANoneMelif();
        }
	nodeList.add(pmelifNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new24() /* reduce AElseMelif */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMelif pmelifNode1;
        {
            // Block
        TElse telseNode2;
        PMstats pmstatsNode3;
        telseNode2 = (TElse)nodeArrayList1.get(0);
        pmstatsNode3 = (PMstats)nodeArrayList2.get(0);

        pmelifNode1 = new AElseMelif(telseNode2, pmstatsNode3);
        }
	nodeList.add(pmelifNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new25() /* reduce AMoreMelif */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMelif pmelifNode1;
        {
            // Block
        TElsif telsifNode2;
        PMexp pmexpNode3;
        TThen tthenNode4;
        PMstats pmstatsNode5;
        PMelif pmelifNode6;
        telsifNode2 = (TElsif)nodeArrayList1.get(0);
        pmexpNode3 = (PMexp)nodeArrayList2.get(0);
        tthenNode4 = (TThen)nodeArrayList3.get(0);
        pmstatsNode5 = (PMstats)nodeArrayList4.get(0);
        pmelifNode6 = (PMelif)nodeArrayList5.get(0);

        pmelifNode1 = new AMoreMelif(telsifNode2, pmexpNode3, tthenNode4, pmstatsNode5, pmelifNode6);
        }
	nodeList.add(pmelifNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new26() /* reduce ACallMexp */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMexp pmexpNode1;
        {
            // Block
        PMcall pmcallNode2;
        pmcallNode2 = (PMcall)nodeArrayList1.get(0);

        pmexpNode1 = new ACallMexp(pmcallNode2);
        }
	nodeList.add(pmexpNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new27() /* reduce ATypeMexp */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMexp pmexpNode1;
        {
            // Block
        PTname ptnameNode2;
        ptnameNode2 = (PTname)nodeArrayList1.get(0);

        pmexpNode1 = new ATypeMexp(ptnameNode2);
        }
	nodeList.add(pmexpNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new28() /* reduce AProcMexp */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMexp pmexpNode1;
        {
            // Block
        TDollar tdollarNode2;
        PTname ptnameNode3;
        TDollar tdollarNode4;
        TIdent tidentNode5;
        tdollarNode2 = (TDollar)nodeArrayList1.get(0);
        ptnameNode3 = (PTname)nodeArrayList2.get(0);
        tdollarNode4 = (TDollar)nodeArrayList3.get(0);
        tidentNode5 = (TIdent)nodeArrayList4.get(0);

        pmexpNode1 = new AProcMexp(tdollarNode2, ptnameNode3, tdollarNode4, tidentNode5);
        }
	nodeList.add(pmexpNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new29() /* reduce ASconstMexp */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMexp pmexpNode1;
        {
            // Block
        TString tstringNode2;
        tstringNode2 = (TString)nodeArrayList1.get(0);

        pmexpNode1 = new ASconstMexp(tstringNode2);
        }
	nodeList.add(pmexpNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new30() /* reduce ANoneMcall */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMcall pmcallNode1;
        {
            // Block
        PMexp pmexpNode2;
        TBang tbangNode3;
        TIdent tidentNode4;
        TKagi tkagiNode5;
        TGika tgikaNode6;
        pmexpNode2 = (PMexp)nodeArrayList1.get(0);
        tbangNode3 = (TBang)nodeArrayList2.get(0);
        tidentNode4 = (TIdent)nodeArrayList3.get(0);
        tkagiNode5 = (TKagi)nodeArrayList4.get(0);
        tgikaNode6 = (TGika)nodeArrayList5.get(0);

        pmcallNode1 = new ANoneMcall(pmexpNode2, tbangNode3, tidentNode4, tkagiNode5, tgikaNode6);
        }
	nodeList.add(pmcallNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new31() /* reduce AArgsMcall */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMcall pmcallNode1;
        {
            // Block
        PMexp pmexpNode2;
        TBang tbangNode3;
        TIdent tidentNode4;
        TKagi tkagiNode5;
        PMargs pmargsNode6;
        TGika tgikaNode7;
        pmexpNode2 = (PMexp)nodeArrayList1.get(0);
        tbangNode3 = (TBang)nodeArrayList2.get(0);
        tidentNode4 = (TIdent)nodeArrayList3.get(0);
        tkagiNode5 = (TKagi)nodeArrayList4.get(0);
        pmargsNode6 = (PMargs)nodeArrayList5.get(0);
        tgikaNode7 = (TGika)nodeArrayList6.get(0);

        pmcallNode1 = new AArgsMcall(pmexpNode2, tbangNode3, tidentNode4, tkagiNode5, pmargsNode6, tgikaNode7);
        }
	nodeList.add(pmcallNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new32() /* reduce AOneMargs */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMargs pmargsNode1;
        {
            // Block
        PMexp pmexpNode2;
        pmexpNode2 = (PMexp)nodeArrayList1.get(0);

        pmargsNode1 = new AOneMargs(pmexpNode2);
        }
	nodeList.add(pmargsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new33() /* reduce ATwoMargs */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMargs pmargsNode1;
        {
            // Block
        PMargs pmargsNode2;
        TComma tcommaNode3;
        PMexp pmexpNode4;
        pmargsNode2 = (PMargs)nodeArrayList1.get(0);
        tcommaNode3 = (TComma)nodeArrayList2.get(0);
        pmexpNode4 = (PMexp)nodeArrayList3.get(0);

        pmargsNode1 = new ATwoMargs(pmargsNode2, tcommaNode3, pmexpNode4);
        }
	nodeList.add(pmargsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new34() /* reduce ACluClus */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList8 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PClus pclusNode1;
        {
            // Block
        TIdent tidentNode2;
        TEql teqlNode3;
        TCluster tclusterNode4;
        PCpara pcparaNode5;
        PAnnot pannotNode6;
        PVdefs pvdefsNode7;
        PPdefs ppdefsNode8;
        TEnd tendNode9;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);
        teqlNode3 = (TEql)nodeArrayList2.get(0);
        tclusterNode4 = (TCluster)nodeArrayList3.get(0);
        pcparaNode5 = (PCpara)nodeArrayList4.get(0);
        pannotNode6 = (PAnnot)nodeArrayList5.get(0);
        pvdefsNode7 = (PVdefs)nodeArrayList6.get(0);
        ppdefsNode8 = (PPdefs)nodeArrayList7.get(0);
        tendNode9 = (TEnd)nodeArrayList8.get(0);

        pclusNode1 = new ACluClus(tidentNode2, teqlNode3, tclusterNode4, pcparaNode5, pannotNode6, pvdefsNode7, ppdefsNode8, tendNode9);
        }
	nodeList.add(pclusNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new35() /* reduce AItfClus */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList8 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PClus pclusNode1;
        {
            // Block
        TIdent tidentNode2;
        TEql teqlNode3;
        TInterface tinterfaceNode4;
        PCpara pcparaNode5;
        PAnnot pannotNode6;
        PVdefs pvdefsNode7;
        PPdefs ppdefsNode8;
        TEnd tendNode9;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);
        teqlNode3 = (TEql)nodeArrayList2.get(0);
        tinterfaceNode4 = (TInterface)nodeArrayList3.get(0);
        pcparaNode5 = (PCpara)nodeArrayList4.get(0);
        pannotNode6 = (PAnnot)nodeArrayList5.get(0);
        pvdefsNode7 = (PVdefs)nodeArrayList6.get(0);
        ppdefsNode8 = (PPdefs)nodeArrayList7.get(0);
        tendNode9 = (TEnd)nodeArrayList8.get(0);

        pclusNode1 = new AItfClus(tidentNode2, teqlNode3, tinterfaceNode4, pcparaNode5, pannotNode6, pvdefsNode7, ppdefsNode8, tendNode9);
        }
	nodeList.add(pclusNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new36() /* reduce AEmpCpara */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PCpara pcparaNode1;
        {
            // Block

        pcparaNode1 = new AEmpCpara();
        }
	nodeList.add(pcparaNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new37() /* reduce AOneCpara */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCpara pcparaNode1;
        {
            // Block
        TKagi tkagiNode2;
        PPlist pplistNode3;
        TGika tgikaNode4;
        tkagiNode2 = (TKagi)nodeArrayList1.get(0);
        pplistNode3 = (PPlist)nodeArrayList2.get(0);
        tgikaNode4 = (TGika)nodeArrayList3.get(0);

        pcparaNode1 = new AOneCpara(tkagiNode2, pplistNode3, tgikaNode4);
        }
	nodeList.add(pcparaNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new38() /* reduce AEmpVdefs */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PVdefs pvdefsNode1;
        {
            // Block

        pvdefsNode1 = new AEmpVdefs();
        }
	nodeList.add(pvdefsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new39() /* reduce AOneVdefs */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVdefs pvdefsNode1;
        {
            // Block
        PVdefs pvdefsNode2;
        PVdef pvdefNode3;
        pvdefsNode2 = (PVdefs)nodeArrayList1.get(0);
        pvdefNode3 = (PVdef)nodeArrayList2.get(0);

        pvdefsNode1 = new AOneVdefs(pvdefsNode2, pvdefNode3);
        }
	nodeList.add(pvdefsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new40() /* reduce AInitVdef */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVdef pvdefNode1;
        {
            // Block
        TVar tvarNode2;
        TIdent tidentNode3;
        TColon tcolonNode4;
        PTname ptnameNode5;
        TAssign tassignNode6;
        PExpr pexprNode7;
        tvarNode2 = (TVar)nodeArrayList1.get(0);
        tidentNode3 = (TIdent)nodeArrayList2.get(0);
        tcolonNode4 = (TColon)nodeArrayList3.get(0);
        ptnameNode5 = (PTname)nodeArrayList4.get(0);
        tassignNode6 = (TAssign)nodeArrayList5.get(0);
        pexprNode7 = (PExpr)nodeArrayList6.get(0);

        pvdefNode1 = new AInitVdef(tvarNode2, tidentNode3, tcolonNode4, ptnameNode5, tassignNode6, pexprNode7);
        }
	nodeList.add(pvdefNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new41() /* reduce ADeclVdef */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVdef pvdefNode1;
        {
            // Block
        TVar tvarNode2;
        TIdent tidentNode3;
        TColon tcolonNode4;
        PTname ptnameNode5;
        tvarNode2 = (TVar)nodeArrayList1.get(0);
        tidentNode3 = (TIdent)nodeArrayList2.get(0);
        tcolonNode4 = (TColon)nodeArrayList3.get(0);
        ptnameNode5 = (PTname)nodeArrayList4.get(0);

        pvdefNode1 = new ADeclVdef(tvarNode2, tidentNode3, tcolonNode4, ptnameNode5);
        }
	nodeList.add(pvdefNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new42() /* reduce AEmpPdefs */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PPdefs ppdefsNode1;
        {
            // Block

        ppdefsNode1 = new AEmpPdefs();
        }
	nodeList.add(ppdefsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new43() /* reduce AOnePdefs */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPdefs ppdefsNode1;
        {
            // Block
        PPdefs ppdefsNode2;
        PPdef ppdefNode3;
        ppdefsNode2 = (PPdefs)nodeArrayList1.get(0);
        ppdefNode3 = (PPdef)nodeArrayList2.get(0);

        ppdefsNode1 = new AOnePdefs(ppdefsNode2, ppdefNode3);
        }
	nodeList.add(ppdefsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new44() /* reduce AFuncPdef */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList11 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList10 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList9 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList8 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPdef ppdefNode1;
        {
            // Block
        TIdent tidentNode2;
        TEql teqlNode3;
        TProc tprocNode4;
        TLpar tlparNode5;
        PParms pparmsNode6;
        TRpar trparNode7;
        TColon tcolonNode8;
        PTname ptnameNode9;
        PAnnot pannotNode10;
        PFbody pfbodyNode11;
        TEnd tendNode12;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);
        teqlNode3 = (TEql)nodeArrayList2.get(0);
        tprocNode4 = (TProc)nodeArrayList3.get(0);
        tlparNode5 = (TLpar)nodeArrayList4.get(0);
        pparmsNode6 = (PParms)nodeArrayList5.get(0);
        trparNode7 = (TRpar)nodeArrayList6.get(0);
        tcolonNode8 = (TColon)nodeArrayList7.get(0);
        ptnameNode9 = (PTname)nodeArrayList8.get(0);
        pannotNode10 = (PAnnot)nodeArrayList9.get(0);
        pfbodyNode11 = (PFbody)nodeArrayList10.get(0);
        tendNode12 = (TEnd)nodeArrayList11.get(0);

        ppdefNode1 = new AFuncPdef(tidentNode2, teqlNode3, tprocNode4, tlparNode5, pparmsNode6, trparNode7, tcolonNode8, ptnameNode9, pannotNode10, pfbodyNode11, tendNode12);
        }
	nodeList.add(ppdefNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new45() /* reduce AVoidPdef */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList9 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList8 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList7 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPdef ppdefNode1;
        {
            // Block
        TIdent tidentNode2;
        TEql teqlNode3;
        TProc tprocNode4;
        TLpar tlparNode5;
        PParms pparmsNode6;
        TRpar trparNode7;
        PAnnot pannotNode8;
        PVbody pvbodyNode9;
        TEnd tendNode10;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);
        teqlNode3 = (TEql)nodeArrayList2.get(0);
        tprocNode4 = (TProc)nodeArrayList3.get(0);
        tlparNode5 = (TLpar)nodeArrayList4.get(0);
        pparmsNode6 = (PParms)nodeArrayList5.get(0);
        trparNode7 = (TRpar)nodeArrayList6.get(0);
        pannotNode8 = (PAnnot)nodeArrayList7.get(0);
        pvbodyNode9 = (PVbody)nodeArrayList8.get(0);
        tendNode10 = (TEnd)nodeArrayList9.get(0);

        ppdefNode1 = new AVoidPdef(tidentNode2, teqlNode3, tprocNode4, tlparNode5, pparmsNode6, trparNode7, pannotNode8, pvbodyNode9, tendNode10);
        }
	nodeList.add(ppdefNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new46() /* reduce AEmpParms */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PParms pparmsNode1;
        {
            // Block

        pparmsNode1 = new AEmpParms();
        }
	nodeList.add(pparmsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new47() /* reduce AListParms */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParms pparmsNode1;
        {
            // Block
        PPlist pplistNode2;
        pplistNode2 = (PPlist)nodeArrayList1.get(0);

        pparmsNode1 = new AListParms(pplistNode2);
        }
	nodeList.add(pparmsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new48() /* reduce AOnePlist */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPlist pplistNode1;
        {
            // Block
        PParm pparmNode2;
        pparmNode2 = (PParm)nodeArrayList1.get(0);

        pplistNode1 = new AOnePlist(pparmNode2);
        }
	nodeList.add(pplistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new49() /* reduce AManyPlist */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPlist pplistNode1;
        {
            // Block
        PPlist pplistNode2;
        TComma tcommaNode3;
        PParm pparmNode4;
        pplistNode2 = (PPlist)nodeArrayList1.get(0);
        tcommaNode3 = (TComma)nodeArrayList2.get(0);
        pparmNode4 = (PParm)nodeArrayList3.get(0);

        pplistNode1 = new AManyPlist(pplistNode2, tcommaNode3, pparmNode4);
        }
	nodeList.add(pplistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new50() /* reduce AOneParm */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PParm pparmNode1;
        {
            // Block
        TIdent tidentNode2;
        TColon tcolonNode3;
        PTname ptnameNode4;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);
        tcolonNode3 = (TColon)nodeArrayList2.get(0);
        ptnameNode4 = (PTname)nodeArrayList3.get(0);

        pparmNode1 = new AOneParm(tidentNode2, tcolonNode3, ptnameNode4);
        }
	nodeList.add(pparmNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new51() /* reduce AOneTname */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTname ptnameNode1;
        {
            // Block
        TIdent tidentNode2;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);

        ptnameNode1 = new AOneTname(tidentNode2);
        }
	nodeList.add(ptnameNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new52() /* reduce AParaTname */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTname ptnameNode1;
        {
            // Block
        TIdent tidentNode2;
        TKagi tkagiNode3;
        PTlist ptlistNode4;
        TGika tgikaNode5;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);
        tkagiNode3 = (TKagi)nodeArrayList2.get(0);
        ptlistNode4 = (PTlist)nodeArrayList3.get(0);
        tgikaNode5 = (TGika)nodeArrayList4.get(0);

        ptnameNode1 = new AParaTname(tidentNode2, tkagiNode3, ptlistNode4, tgikaNode5);
        }
	nodeList.add(ptnameNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new53() /* reduce AOneTlist */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTlist ptlistNode1;
        {
            // Block
        PTname ptnameNode2;
        ptnameNode2 = (PTname)nodeArrayList1.get(0);

        ptlistNode1 = new AOneTlist(ptnameNode2);
        }
	nodeList.add(ptlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new54() /* reduce AManyTlist */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PTlist ptlistNode1;
        {
            // Block
        PTlist ptlistNode2;
        TComma tcommaNode3;
        PTname ptnameNode4;
        ptlistNode2 = (PTlist)nodeArrayList1.get(0);
        tcommaNode3 = (TComma)nodeArrayList2.get(0);
        ptnameNode4 = (PTname)nodeArrayList3.get(0);

        ptlistNode1 = new AManyTlist(ptlistNode2, tcommaNode3, ptnameNode4);
        }
	nodeList.add(ptlistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new55() /* reduce AEmpFbody */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PFbody pfbodyNode1;
        {
            // Block

        pfbodyNode1 = new AEmpFbody();
        }
	nodeList.add(pfbodyNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new56() /* reduce AOneFbody */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFbody pfbodyNode1;
        {
            // Block
        PFbody pfbodyNode2;
        PFstmt pfstmtNode3;
        POptsm poptsmNode4;
        pfbodyNode2 = (PFbody)nodeArrayList1.get(0);
        pfstmtNode3 = (PFstmt)nodeArrayList2.get(0);
        poptsmNode4 = (POptsm)nodeArrayList3.get(0);

        pfbodyNode1 = new AOneFbody(pfbodyNode2, pfstmtNode3, poptsmNode4);
        }
	nodeList.add(pfbodyNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new57() /* reduce AEmpVbody */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PVbody pvbodyNode1;
        {
            // Block

        pvbodyNode1 = new AEmpVbody();
        }
	nodeList.add(pvbodyNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new58() /* reduce AOneVbody */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVbody pvbodyNode1;
        {
            // Block
        PVbody pvbodyNode2;
        PVstmt pvstmtNode3;
        POptsm poptsmNode4;
        pvbodyNode2 = (PVbody)nodeArrayList1.get(0);
        pvstmtNode3 = (PVstmt)nodeArrayList2.get(0);
        poptsmNode4 = (POptsm)nodeArrayList3.get(0);

        pvbodyNode1 = new AOneVbody(pvbodyNode2, pvstmtNode3, poptsmNode4);
        }
	nodeList.add(pvbodyNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new59() /* reduce AAscalFstmt */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFstmt pfstmtNode1;
        {
            // Block
        PAscal pascalNode2;
        pascalNode2 = (PAscal)nodeArrayList1.get(0);

        pfstmtNode1 = new AAscalFstmt(pascalNode2);
        }
	nodeList.add(pfstmtNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new60() /* reduce ARetnFstmt */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFstmt pfstmtNode1;
        {
            // Block
        TReturn treturnNode2;
        PExpr pexprNode3;
        treturnNode2 = (TReturn)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);

        pfstmtNode1 = new ARetnFstmt(treturnNode2, pexprNode3);
        }
	nodeList.add(pfstmtNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new61() /* reduce AWhstFstmt */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFstmt pfstmtNode1;
        {
            // Block
        TWhile twhileNode2;
        PExpr pexprNode3;
        TDo tdoNode4;
        PFbody pfbodyNode5;
        TEnd tendNode6;
        twhileNode2 = (TWhile)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        tdoNode4 = (TDo)nodeArrayList3.get(0);
        pfbodyNode5 = (PFbody)nodeArrayList4.get(0);
        tendNode6 = (TEnd)nodeArrayList5.get(0);

        pfstmtNode1 = new AWhstFstmt(twhileNode2, pexprNode3, tdoNode4, pfbodyNode5, tendNode6);
        }
	nodeList.add(pfstmtNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new62() /* reduce AIfstFstmt */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFstmt pfstmtNode1;
        {
            // Block
        TIf tifNode2;
        PExpr pexprNode3;
        TThen tthenNode4;
        PFbody pfbodyNode5;
        PFelif pfelifNode6;
        TEnd tendNode7;
        tifNode2 = (TIf)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        tthenNode4 = (TThen)nodeArrayList3.get(0);
        pfbodyNode5 = (PFbody)nodeArrayList4.get(0);
        pfelifNode6 = (PFelif)nodeArrayList5.get(0);
        tendNode7 = (TEnd)nodeArrayList6.get(0);

        pfstmtNode1 = new AIfstFstmt(tifNode2, pexprNode3, tthenNode4, pfbodyNode5, pfelifNode6, tendNode7);
        }
	nodeList.add(pfstmtNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new63() /* reduce ANoneFelif */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PFelif pfelifNode1;
        {
            // Block

        pfelifNode1 = new ANoneFelif();
        }
	nodeList.add(pfelifNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new64() /* reduce AElseFelif */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFelif pfelifNode1;
        {
            // Block
        TElse telseNode2;
        PFbody pfbodyNode3;
        telseNode2 = (TElse)nodeArrayList1.get(0);
        pfbodyNode3 = (PFbody)nodeArrayList2.get(0);

        pfelifNode1 = new AElseFelif(telseNode2, pfbodyNode3);
        }
	nodeList.add(pfelifNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new65() /* reduce AMoreFelif */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PFelif pfelifNode1;
        {
            // Block
        TElsif telsifNode2;
        PExpr pexprNode3;
        TThen tthenNode4;
        PFbody pfbodyNode5;
        PFelif pfelifNode6;
        telsifNode2 = (TElsif)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        tthenNode4 = (TThen)nodeArrayList3.get(0);
        pfbodyNode5 = (PFbody)nodeArrayList4.get(0);
        pfelifNode6 = (PFelif)nodeArrayList5.get(0);

        pfelifNode1 = new AMoreFelif(telsifNode2, pexprNode3, tthenNode4, pfbodyNode5, pfelifNode6);
        }
	nodeList.add(pfelifNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new66() /* reduce AAscalVstmt */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVstmt pvstmtNode1;
        {
            // Block
        PAscal pascalNode2;
        pascalNode2 = (PAscal)nodeArrayList1.get(0);

        pvstmtNode1 = new AAscalVstmt(pascalNode2);
        }
	nodeList.add(pvstmtNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new67() /* reduce ARetnVstmt */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVstmt pvstmtNode1;
        {
            // Block
        TReturn treturnNode2;
        treturnNode2 = (TReturn)nodeArrayList1.get(0);

        pvstmtNode1 = new ARetnVstmt(treturnNode2);
        }
	nodeList.add(pvstmtNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new68() /* reduce AWhstVstmt */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVstmt pvstmtNode1;
        {
            // Block
        TWhile twhileNode2;
        PExpr pexprNode3;
        TDo tdoNode4;
        PVbody pvbodyNode5;
        TEnd tendNode6;
        twhileNode2 = (TWhile)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        tdoNode4 = (TDo)nodeArrayList3.get(0);
        pvbodyNode5 = (PVbody)nodeArrayList4.get(0);
        tendNode6 = (TEnd)nodeArrayList5.get(0);

        pvstmtNode1 = new AWhstVstmt(twhileNode2, pexprNode3, tdoNode4, pvbodyNode5, tendNode6);
        }
	nodeList.add(pvstmtNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new69() /* reduce AIfstVstmt */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVstmt pvstmtNode1;
        {
            // Block
        TIf tifNode2;
        PExpr pexprNode3;
        TThen tthenNode4;
        PVbody pvbodyNode5;
        PVelif pvelifNode6;
        TEnd tendNode7;
        tifNode2 = (TIf)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        tthenNode4 = (TThen)nodeArrayList3.get(0);
        pvbodyNode5 = (PVbody)nodeArrayList4.get(0);
        pvelifNode6 = (PVelif)nodeArrayList5.get(0);
        tendNode7 = (TEnd)nodeArrayList6.get(0);

        pvstmtNode1 = new AIfstVstmt(tifNode2, pexprNode3, tthenNode4, pvbodyNode5, pvelifNode6, tendNode7);
        }
	nodeList.add(pvstmtNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new70() /* reduce ANoneVelif */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        PVelif pvelifNode1;
        {
            // Block

        pvelifNode1 = new ANoneVelif();
        }
	nodeList.add(pvelifNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new71() /* reduce AElseVelif */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVelif pvelifNode1;
        {
            // Block
        TElse telseNode2;
        PVbody pvbodyNode3;
        telseNode2 = (TElse)nodeArrayList1.get(0);
        pvbodyNode3 = (PVbody)nodeArrayList2.get(0);

        pvelifNode1 = new AElseVelif(telseNode2, pvbodyNode3);
        }
	nodeList.add(pvelifNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new72() /* reduce AMoreVelif */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PVelif pvelifNode1;
        {
            // Block
        TElsif telsifNode2;
        PExpr pexprNode3;
        TThen tthenNode4;
        PVbody pvbodyNode5;
        PVelif pvelifNode6;
        telsifNode2 = (TElsif)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        tthenNode4 = (TThen)nodeArrayList3.get(0);
        pvbodyNode5 = (PVbody)nodeArrayList4.get(0);
        pvelifNode6 = (PVelif)nodeArrayList5.get(0);

        pvelifNode1 = new AMoreVelif(telsifNode2, pexprNode3, tthenNode4, pvbodyNode5, pvelifNode6);
        }
	nodeList.add(pvelifNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new73() /* reduce AVdefAscal */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAscal pascalNode1;
        {
            // Block
        PVdef pvdefNode2;
        pvdefNode2 = (PVdef)nodeArrayList1.get(0);

        pascalNode1 = new AVdefAscal(pvdefNode2);
        }
	nodeList.add(pascalNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new74() /* reduce AAssignAscal */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAscal pascalNode1;
        {
            // Block
        TIdent tidentNode2;
        TAssign tassignNode3;
        PExpr pexprNode4;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);
        tassignNode3 = (TAssign)nodeArrayList2.get(0);
        pexprNode4 = (PExpr)nodeArrayList3.get(0);

        pascalNode1 = new AAssignAscal(tidentNode2, tassignNode3, pexprNode4);
        }
	nodeList.add(pascalNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new75() /* reduce AAstoreAscal */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList6 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAscal pascalNode1;
        {
            // Block
        PPmmex ppmmexNode2;
        TKagi tkagiNode3;
        PExpr pexprNode4;
        TGika tgikaNode5;
        TAssign tassignNode6;
        PExpr pexprNode7;
        ppmmexNode2 = (PPmmex)nodeArrayList1.get(0);
        tkagiNode3 = (TKagi)nodeArrayList2.get(0);
        pexprNode4 = (PExpr)nodeArrayList3.get(0);
        tgikaNode5 = (TGika)nodeArrayList4.get(0);
        tassignNode6 = (TAssign)nodeArrayList5.get(0);
        pexprNode7 = (PExpr)nodeArrayList6.get(0);

        pascalNode1 = new AAstoreAscal(ppmmexNode2, tkagiNode3, pexprNode4, tgikaNode5, tassignNode6, pexprNode7);
        }
	nodeList.add(pascalNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new76() /* reduce APstoreAscal */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAscal pascalNode1;
        {
            // Block
        PPmmex ppmmexNode2;
        TPeri tperiNode3;
        TIdent tidentNode4;
        TAssign tassignNode5;
        PExpr pexprNode6;
        ppmmexNode2 = (PPmmex)nodeArrayList1.get(0);
        tperiNode3 = (TPeri)nodeArrayList2.get(0);
        tidentNode4 = (TIdent)nodeArrayList3.get(0);
        tassignNode5 = (TAssign)nodeArrayList4.get(0);
        pexprNode6 = (PExpr)nodeArrayList5.get(0);

        pascalNode1 = new APstoreAscal(ppmmexNode2, tperiNode3, tidentNode4, tassignNode5, pexprNode6);
        }
	nodeList.add(pascalNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new77() /* reduce ACallAscal */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAscal pascalNode1;
        {
            // Block
        PPclex ppclexNode2;
        ppclexNode2 = (PPclex)nodeArrayList1.get(0);

        pascalNode1 = new ACallAscal(ppclexNode2);
        }
	nodeList.add(pascalNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new78() /* reduce AOrexpExpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PExpr pexprNode1;
        {
            // Block
        POrexp porexpNode2;
        porexpNode2 = (POrexp)nodeArrayList1.get(0);

        pexprNode1 = new AOrexpExpr(porexpNode2);
        }
	nodeList.add(pexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new79() /* reduce AAndexOrexp */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        POrexp porexpNode1;
        {
            // Block
        PAndex pandexNode2;
        pandexNode2 = (PAndex)nodeArrayList1.get(0);

        porexpNode1 = new AAndexOrexp(pandexNode2);
        }
	nodeList.add(porexpNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new80() /* reduce ACorOrexp */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        POrexp porexpNode1;
        {
            // Block
        POrexp porexpNode2;
        TCor tcorNode3;
        PAndex pandexNode4;
        porexpNode2 = (POrexp)nodeArrayList1.get(0);
        tcorNode3 = (TCor)nodeArrayList2.get(0);
        pandexNode4 = (PAndex)nodeArrayList3.get(0);

        porexpNode1 = new ACorOrexp(porexpNode2, tcorNode3, pandexNode4);
        }
	nodeList.add(porexpNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new81() /* reduce ARelexAndex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAndex pandexNode1;
        {
            // Block
        PRelex prelexNode2;
        prelexNode2 = (PRelex)nodeArrayList1.get(0);

        pandexNode1 = new ARelexAndex(prelexNode2);
        }
	nodeList.add(pandexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new82() /* reduce ACandAndex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAndex pandexNode1;
        {
            // Block
        PAndex pandexNode2;
        TCand tcandNode3;
        PRelex prelexNode4;
        pandexNode2 = (PAndex)nodeArrayList1.get(0);
        tcandNode3 = (TCand)nodeArrayList2.get(0);
        prelexNode4 = (PRelex)nodeArrayList3.get(0);

        pandexNode1 = new ACandAndex(pandexNode2, tcandNode3, prelexNode4);
        }
	nodeList.add(pandexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new83() /* reduce AAddexRelex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PRelex prelexNode1;
        {
            // Block
        PAddex paddexNode2;
        paddexNode2 = (PAddex)nodeArrayList1.get(0);

        prelexNode1 = new AAddexRelex(paddexNode2);
        }
	nodeList.add(prelexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new84() /* reduce AEqlRelex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PRelex prelexNode1;
        {
            // Block
        PAddex paddexNode2;
        TEql teqlNode3;
        PAddex paddexNode4;
        paddexNode2 = (PAddex)nodeArrayList1.get(0);
        teqlNode3 = (TEql)nodeArrayList2.get(0);
        paddexNode4 = (PAddex)nodeArrayList3.get(0);

        prelexNode1 = new AEqlRelex(paddexNode2, teqlNode3, paddexNode4);
        }
	nodeList.add(prelexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new85() /* reduce ANoteqRelex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PRelex prelexNode1;
        {
            // Block
        PAddex paddexNode2;
        TNoteq tnoteqNode3;
        PAddex paddexNode4;
        paddexNode2 = (PAddex)nodeArrayList1.get(0);
        tnoteqNode3 = (TNoteq)nodeArrayList2.get(0);
        paddexNode4 = (PAddex)nodeArrayList3.get(0);

        prelexNode1 = new ANoteqRelex(paddexNode2, tnoteqNode3, paddexNode4);
        }
	nodeList.add(prelexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new86() /* reduce ALtRelex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PRelex prelexNode1;
        {
            // Block
        PAddex paddexNode2;
        TLt tltNode3;
        PAddex paddexNode4;
        paddexNode2 = (PAddex)nodeArrayList1.get(0);
        tltNode3 = (TLt)nodeArrayList2.get(0);
        paddexNode4 = (PAddex)nodeArrayList3.get(0);

        prelexNode1 = new ALtRelex(paddexNode2, tltNode3, paddexNode4);
        }
	nodeList.add(prelexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new87() /* reduce AGtRelex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PRelex prelexNode1;
        {
            // Block
        PAddex paddexNode2;
        TGt tgtNode3;
        PAddex paddexNode4;
        paddexNode2 = (PAddex)nodeArrayList1.get(0);
        tgtNode3 = (TGt)nodeArrayList2.get(0);
        paddexNode4 = (PAddex)nodeArrayList3.get(0);

        prelexNode1 = new AGtRelex(paddexNode2, tgtNode3, paddexNode4);
        }
	nodeList.add(prelexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new88() /* reduce ALeRelex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PRelex prelexNode1;
        {
            // Block
        PAddex paddexNode2;
        TLe tleNode3;
        PAddex paddexNode4;
        paddexNode2 = (PAddex)nodeArrayList1.get(0);
        tleNode3 = (TLe)nodeArrayList2.get(0);
        paddexNode4 = (PAddex)nodeArrayList3.get(0);

        prelexNode1 = new ALeRelex(paddexNode2, tleNode3, paddexNode4);
        }
	nodeList.add(prelexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new89() /* reduce AGeRelex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PRelex prelexNode1;
        {
            // Block
        PAddex paddexNode2;
        TGe tgeNode3;
        PAddex paddexNode4;
        paddexNode2 = (PAddex)nodeArrayList1.get(0);
        tgeNode3 = (TGe)nodeArrayList2.get(0);
        paddexNode4 = (PAddex)nodeArrayList3.get(0);

        prelexNode1 = new AGeRelex(paddexNode2, tgeNode3, paddexNode4);
        }
	nodeList.add(prelexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new90() /* reduce AMulexAddex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAddex paddexNode1;
        {
            // Block
        PMulex pmulexNode2;
        pmulexNode2 = (PMulex)nodeArrayList1.get(0);

        paddexNode1 = new AMulexAddex(pmulexNode2);
        }
	nodeList.add(paddexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new91() /* reduce AAddAddex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAddex paddexNode1;
        {
            // Block
        PAddex paddexNode2;
        TPlus tplusNode3;
        PMulex pmulexNode4;
        paddexNode2 = (PAddex)nodeArrayList1.get(0);
        tplusNode3 = (TPlus)nodeArrayList2.get(0);
        pmulexNode4 = (PMulex)nodeArrayList3.get(0);

        paddexNode1 = new AAddAddex(paddexNode2, tplusNode3, pmulexNode4);
        }
	nodeList.add(paddexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new92() /* reduce ASubAddex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAddex paddexNode1;
        {
            // Block
        PAddex paddexNode2;
        TMinus tminusNode3;
        PMulex pmulexNode4;
        paddexNode2 = (PAddex)nodeArrayList1.get(0);
        tminusNode3 = (TMinus)nodeArrayList2.get(0);
        pmulexNode4 = (PMulex)nodeArrayList3.get(0);

        paddexNode1 = new ASubAddex(paddexNode2, tminusNode3, pmulexNode4);
        }
	nodeList.add(paddexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new93() /* reduce AUexprMulex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMulex pmulexNode1;
        {
            // Block
        PUexpr puexprNode2;
        puexprNode2 = (PUexpr)nodeArrayList1.get(0);

        pmulexNode1 = new AUexprMulex(puexprNode2);
        }
	nodeList.add(pmulexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new94() /* reduce AMulMulex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMulex pmulexNode1;
        {
            // Block
        PMulex pmulexNode2;
        TMult tmultNode3;
        PUexpr puexprNode4;
        pmulexNode2 = (PMulex)nodeArrayList1.get(0);
        tmultNode3 = (TMult)nodeArrayList2.get(0);
        puexprNode4 = (PUexpr)nodeArrayList3.get(0);

        pmulexNode1 = new AMulMulex(pmulexNode2, tmultNode3, puexprNode4);
        }
	nodeList.add(pmulexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new95() /* reduce ADivMulex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMulex pmulexNode1;
        {
            // Block
        PMulex pmulexNode2;
        TDiv tdivNode3;
        PUexpr puexprNode4;
        pmulexNode2 = (PMulex)nodeArrayList1.get(0);
        tdivNode3 = (TDiv)nodeArrayList2.get(0);
        puexprNode4 = (PUexpr)nodeArrayList3.get(0);

        pmulexNode1 = new ADivMulex(pmulexNode2, tdivNode3, puexprNode4);
        }
	nodeList.add(pmulexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new96() /* reduce ARemMulex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMulex pmulexNode1;
        {
            // Block
        PMulex pmulexNode2;
        TRem tremNode3;
        PUexpr puexprNode4;
        pmulexNode2 = (PMulex)nodeArrayList1.get(0);
        tremNode3 = (TRem)nodeArrayList2.get(0);
        puexprNode4 = (PUexpr)nodeArrayList3.get(0);

        pmulexNode1 = new ARemMulex(pmulexNode2, tremNode3, puexprNode4);
        }
	nodeList.add(pmulexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new97() /* reduce ACalexUexpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PUexpr puexprNode1;
        {
            // Block
        PCalex pcalexNode2;
        pcalexNode2 = (PCalex)nodeArrayList1.get(0);

        puexprNode1 = new ACalexUexpr(pcalexNode2);
        }
	nodeList.add(puexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new98() /* reduce AMemexUexpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PUexpr puexprNode1;
        {
            // Block
        PMemex pmemexNode2;
        pmemexNode2 = (PMemex)nodeArrayList1.get(0);

        puexprNode1 = new AMemexUexpr(pmemexNode2);
        }
	nodeList.add(puexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new99() /* reduce AMinusUexpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PUexpr puexprNode1;
        {
            // Block
        TMinus tminusNode2;
        PCalex pcalexNode3;
        tminusNode2 = (TMinus)nodeArrayList1.get(0);
        pcalexNode3 = (PCalex)nodeArrayList2.get(0);

        puexprNode1 = new AMinusUexpr(tminusNode2, pcalexNode3);
        }
	nodeList.add(puexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new100() /* reduce APlusUexpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PUexpr puexprNode1;
        {
            // Block
        TPlus tplusNode2;
        PCalex pcalexNode3;
        tplusNode2 = (TPlus)nodeArrayList1.get(0);
        pcalexNode3 = (PCalex)nodeArrayList2.get(0);

        puexprNode1 = new APlusUexpr(tplusNode2, pcalexNode3);
        }
	nodeList.add(puexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new101() /* reduce ABangUexpr */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PUexpr puexprNode1;
        {
            // Block
        TBang tbangNode2;
        PCalex pcalexNode3;
        tbangNode2 = (TBang)nodeArrayList1.get(0);
        pcalexNode3 = (PCalex)nodeArrayList2.get(0);

        puexprNode1 = new ABangUexpr(tbangNode2, pcalexNode3);
        }
	nodeList.add(puexprNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new102() /* reduce AEmptyArgs */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PArgs pargsNode1;
        {
            // Block
        TLpar tlparNode2;
        TRpar trparNode3;
        tlparNode2 = (TLpar)nodeArrayList1.get(0);
        trparNode3 = (TRpar)nodeArrayList2.get(0);

        pargsNode1 = new AEmptyArgs(tlparNode2, trparNode3);
        }
	nodeList.add(pargsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new103() /* reduce AListArgs */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PArgs pargsNode1;
        {
            // Block
        TLpar tlparNode2;
        PAlist palistNode3;
        TRpar trparNode4;
        tlparNode2 = (TLpar)nodeArrayList1.get(0);
        palistNode3 = (PAlist)nodeArrayList2.get(0);
        trparNode4 = (TRpar)nodeArrayList3.get(0);

        pargsNode1 = new AListArgs(tlparNode2, palistNode3, trparNode4);
        }
	nodeList.add(pargsNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new104() /* reduce AOneAlist */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAlist palistNode1;
        {
            // Block
        PExpr pexprNode2;
        pexprNode2 = (PExpr)nodeArrayList1.get(0);

        palistNode1 = new AOneAlist(pexprNode2);
        }
	nodeList.add(palistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new105() /* reduce AListAlist */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PAlist palistNode1;
        {
            // Block
        PAlist palistNode2;
        TComma tcommaNode3;
        PExpr pexprNode4;
        palistNode2 = (PAlist)nodeArrayList1.get(0);
        tcommaNode3 = (TComma)nodeArrayList2.get(0);
        pexprNode4 = (PExpr)nodeArrayList3.get(0);

        palistNode1 = new AListAlist(palistNode2, tcommaNode3, pexprNode4);
        }
	nodeList.add(palistNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new106() /* reduce ATypeCalex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCalex pcalexNode1;
        {
            // Block
        TDollar tdollarNode2;
        PTname ptnameNode3;
        TDollar tdollarNode4;
        TIdent tidentNode5;
        PArgs pargsNode6;
        tdollarNode2 = (TDollar)nodeArrayList1.get(0);
        ptnameNode3 = (PTname)nodeArrayList2.get(0);
        tdollarNode4 = (TDollar)nodeArrayList3.get(0);
        tidentNode5 = (TIdent)nodeArrayList4.get(0);
        pargsNode6 = (PArgs)nodeArrayList5.get(0);

        pcalexNode1 = new ATypeCalex(tdollarNode2, ptnameNode3, tdollarNode4, tidentNode5, pargsNode6);
        }
	nodeList.add(pcalexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new107() /* reduce AMemexCalex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCalex pcalexNode1;
        {
            // Block
        PMemex pmemexNode2;
        TBang tbangNode3;
        TIdent tidentNode4;
        PArgs pargsNode5;
        pmemexNode2 = (PMemex)nodeArrayList1.get(0);
        tbangNode3 = (TBang)nodeArrayList2.get(0);
        tidentNode4 = (TIdent)nodeArrayList3.get(0);
        pargsNode5 = (PArgs)nodeArrayList4.get(0);

        pcalexNode1 = new AMemexCalex(pmemexNode2, tbangNode3, tidentNode4, pargsNode5);
        }
	nodeList.add(pcalexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new108() /* reduce ACascCalex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCalex pcalexNode1;
        {
            // Block
        PCalex pcalexNode2;
        TBang tbangNode3;
        TIdent tidentNode4;
        PArgs pargsNode5;
        pcalexNode2 = (PCalex)nodeArrayList1.get(0);
        tbangNode3 = (TBang)nodeArrayList2.get(0);
        tidentNode4 = (TIdent)nodeArrayList3.get(0);
        pargsNode5 = (PArgs)nodeArrayList4.get(0);

        pcalexNode1 = new ACascCalex(pcalexNode2, tbangNode3, tidentNode4, pargsNode5);
        }
	nodeList.add(pcalexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new109() /* reduce APropCalex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCalex pcalexNode1;
        {
            // Block
        PCalex pcalexNode2;
        TPeri tperiNode3;
        TIdent tidentNode4;
        pcalexNode2 = (PCalex)nodeArrayList1.get(0);
        tperiNode3 = (TPeri)nodeArrayList2.get(0);
        tidentNode4 = (TIdent)nodeArrayList3.get(0);

        pcalexNode1 = new APropCalex(pcalexNode2, tperiNode3, tidentNode4);
        }
	nodeList.add(pcalexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new110() /* reduce AArrayCalex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PCalex pcalexNode1;
        {
            // Block
        PCalex pcalexNode2;
        TKagi tkagiNode3;
        PExpr pexprNode4;
        TGika tgikaNode5;
        pcalexNode2 = (PCalex)nodeArrayList1.get(0);
        tkagiNode3 = (TKagi)nodeArrayList2.get(0);
        pexprNode4 = (PExpr)nodeArrayList3.get(0);
        tgikaNode5 = (TGika)nodeArrayList4.get(0);

        pcalexNode1 = new AArrayCalex(pcalexNode2, tkagiNode3, pexprNode4, tgikaNode5);
        }
	nodeList.add(pcalexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new111() /* reduce AIdentMemex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMemex pmemexNode1;
        {
            // Block
        TIdent tidentNode2;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);

        pmemexNode1 = new AIdentMemex(tidentNode2);
        }
	nodeList.add(pmemexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new112() /* reduce AConstMemex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMemex pmemexNode1;
        {
            // Block
        PConst pconstNode2;
        pconstNode2 = (PConst)nodeArrayList1.get(0);

        pmemexNode1 = new AConstMemex(pconstNode2);
        }
	nodeList.add(pmemexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new113() /* reduce APropMemex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMemex pmemexNode1;
        {
            // Block
        PMemex pmemexNode2;
        TPeri tperiNode3;
        TIdent tidentNode4;
        pmemexNode2 = (PMemex)nodeArrayList1.get(0);
        tperiNode3 = (TPeri)nodeArrayList2.get(0);
        tidentNode4 = (TIdent)nodeArrayList3.get(0);

        pmemexNode1 = new APropMemex(pmemexNode2, tperiNode3, tidentNode4);
        }
	nodeList.add(pmemexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new114() /* reduce AArrayMemex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMemex pmemexNode1;
        {
            // Block
        PMemex pmemexNode2;
        TKagi tkagiNode3;
        PExpr pexprNode4;
        TGika tgikaNode5;
        pmemexNode2 = (PMemex)nodeArrayList1.get(0);
        tkagiNode3 = (TKagi)nodeArrayList2.get(0);
        pexprNode4 = (PExpr)nodeArrayList3.get(0);
        tgikaNode5 = (TGika)nodeArrayList4.get(0);

        pmemexNode1 = new AArrayMemex(pmemexNode2, tkagiNode3, pexprNode4, tgikaNode5);
        }
	nodeList.add(pmemexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new115() /* reduce AParenMemex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PMemex pmemexNode1;
        {
            // Block
        TLpar tlparNode2;
        PExpr pexprNode3;
        TRpar trparNode4;
        tlparNode2 = (TLpar)nodeArrayList1.get(0);
        pexprNode3 = (PExpr)nodeArrayList2.get(0);
        trparNode4 = (TRpar)nodeArrayList3.get(0);

        pmemexNode1 = new AParenMemex(tlparNode2, pexprNode3, trparNode4);
        }
	nodeList.add(pmemexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new116() /* reduce ATypePclex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList5 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPclex ppclexNode1;
        {
            // Block
        TDollar tdollarNode2;
        PTname ptnameNode3;
        TDollar tdollarNode4;
        TIdent tidentNode5;
        PArgs pargsNode6;
        tdollarNode2 = (TDollar)nodeArrayList1.get(0);
        ptnameNode3 = (PTname)nodeArrayList2.get(0);
        tdollarNode4 = (TDollar)nodeArrayList3.get(0);
        tidentNode5 = (TIdent)nodeArrayList4.get(0);
        pargsNode6 = (PArgs)nodeArrayList5.get(0);

        ppclexNode1 = new ATypePclex(tdollarNode2, ptnameNode3, tdollarNode4, tidentNode5, pargsNode6);
        }
	nodeList.add(ppclexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new117() /* reduce ACallPclex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPclex ppclexNode1;
        {
            // Block
        PPmmex ppmmexNode2;
        TBang tbangNode3;
        TIdent tidentNode4;
        PArgs pargsNode5;
        ppmmexNode2 = (PPmmex)nodeArrayList1.get(0);
        tbangNode3 = (TBang)nodeArrayList2.get(0);
        tidentNode4 = (TIdent)nodeArrayList3.get(0);
        pargsNode5 = (PArgs)nodeArrayList4.get(0);

        ppclexNode1 = new ACallPclex(ppmmexNode2, tbangNode3, tidentNode4, pargsNode5);
        }
	nodeList.add(ppclexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new118() /* reduce ACascPclex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPclex ppclexNode1;
        {
            // Block
        PPclex ppclexNode2;
        TBang tbangNode3;
        TIdent tidentNode4;
        PArgs pargsNode5;
        ppclexNode2 = (PPclex)nodeArrayList1.get(0);
        tbangNode3 = (TBang)nodeArrayList2.get(0);
        tidentNode4 = (TIdent)nodeArrayList3.get(0);
        pargsNode5 = (PArgs)nodeArrayList4.get(0);

        ppclexNode1 = new ACascPclex(ppclexNode2, tbangNode3, tidentNode4, pargsNode5);
        }
	nodeList.add(ppclexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new119() /* reduce AIdentPmmex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPmmex ppmmexNode1;
        {
            // Block
        TIdent tidentNode2;
        tidentNode2 = (TIdent)nodeArrayList1.get(0);

        ppmmexNode1 = new AIdentPmmex(tidentNode2);
        }
	nodeList.add(ppmmexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new120() /* reduce AConstPmmex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPmmex ppmmexNode1;
        {
            // Block
        PConst pconstNode2;
        pconstNode2 = (PConst)nodeArrayList1.get(0);

        ppmmexNode1 = new AConstPmmex(pconstNode2);
        }
	nodeList.add(ppmmexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new121() /* reduce APropPmmex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPmmex ppmmexNode1;
        {
            // Block
        PPmmex ppmmexNode2;
        TPeri tperiNode3;
        TIdent tidentNode4;
        ppmmexNode2 = (PPmmex)nodeArrayList1.get(0);
        tperiNode3 = (TPeri)nodeArrayList2.get(0);
        tidentNode4 = (TIdent)nodeArrayList3.get(0);

        ppmmexNode1 = new APropPmmex(ppmmexNode2, tperiNode3, tidentNode4);
        }
	nodeList.add(ppmmexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new122() /* reduce AArrayPmmex */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList4 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList3 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList2 = pop();
        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PPmmex ppmmexNode1;
        {
            // Block
        PPmmex ppmmexNode2;
        TKagi tkagiNode3;
        PExpr pexprNode4;
        TGika tgikaNode5;
        ppmmexNode2 = (PPmmex)nodeArrayList1.get(0);
        tkagiNode3 = (TKagi)nodeArrayList2.get(0);
        pexprNode4 = (PExpr)nodeArrayList3.get(0);
        tgikaNode5 = (TGika)nodeArrayList4.get(0);

        ppmmexNode1 = new AArrayPmmex(ppmmexNode2, tkagiNode3, pexprNode4, tgikaNode5);
        }
	nodeList.add(ppmmexNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new123() /* reduce AIconstConst */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PConst pconstNode1;
        {
            // Block
        TIconst ticonstNode2;
        ticonstNode2 = (TIconst)nodeArrayList1.get(0);

        pconstNode1 = new AIconstConst(ticonstNode2);
        }
	nodeList.add(pconstNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new124() /* reduce ASconstConst */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PConst pconstNode1;
        {
            // Block
        TString tstringNode2;
        tstringNode2 = (TString)nodeArrayList1.get(0);

        pconstNode1 = new ASconstConst(tstringNode2);
        }
	nodeList.add(pconstNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new125() /* reduce AFalseConst */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PConst pconstNode1;
        {
            // Block
        TFalse tfalseNode2;
        tfalseNode2 = (TFalse)nodeArrayList1.get(0);

        pconstNode1 = new AFalseConst(tfalseNode2);
        }
	nodeList.add(pconstNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new126() /* reduce ATrueConst */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PConst pconstNode1;
        {
            // Block
        TTrue ttrueNode2;
        ttrueNode2 = (TTrue)nodeArrayList1.get(0);

        pconstNode1 = new ATrueConst(ttrueNode2);
        }
	nodeList.add(pconstNode1);
        return nodeList;
    }



    @SuppressWarnings("unchecked")
    ArrayList new127() /* reduce ANilConst */
    {
        @SuppressWarnings("hiding") ArrayList nodeList = new ArrayList();

        @SuppressWarnings("unused") ArrayList nodeArrayList1 = pop();
        PConst pconstNode1;
        {
            // Block
        TNil tnilNode2;
        tnilNode2 = (TNil)nodeArrayList1.get(0);

        pconstNode1 = new ANilConst(tnilNode2);
        }
	nodeList.add(pconstNode1);
        return nodeList;
    }



    private static int[][][] actionTable;
/*      {
			{{-1, REDUCE, 0}, },
			{{-1, ERROR, 1}, {45, SHIFT, 2}, {47, ACCEPT, -1}, },
			{{-1, ERROR, 2}, {35, SHIFT, 5}, },
			{{-1, REDUCE, 2}, },
			{{-1, REDUCE, 1}, },
			{{-1, ERROR, 5}, {0, SHIFT, 6}, {8, SHIFT, 7}, {9, SHIFT, 8}, {11, SHIFT, 9}, },
			{{-1, REDUCE, 36}, {28, SHIFT, 10}, },
			{{-1, REDUCE, 36}, {28, SHIFT, 10}, },
			{{-1, REDUCE, 36}, {28, SHIFT, 10}, },
			{{-1, REDUCE, 36}, {28, SHIFT, 10}, },
			{{-1, ERROR, 10}, {45, SHIFT, 15}, },
			{{-1, REDUCE, 3}, },
			{{-1, REDUCE, 3}, },
			{{-1, REDUCE, 3}, },
			{{-1, REDUCE, 3}, },
			{{-1, ERROR, 15}, {33, SHIFT, 22}, },
			{{-1, ERROR, 16}, {29, SHIFT, 23}, {30, SHIFT, 24}, },
			{{-1, REDUCE, 48}, },
			{{-1, REDUCE, 38}, {19, SHIFT, 25}, },
			{{-1, REDUCE, 38}, {19, SHIFT, 25}, },
			{{-1, REDUCE, 18}, {19, SHIFT, 25}, },
			{{-1, REDUCE, 18}, {19, SHIFT, 25}, },
			{{-1, ERROR, 22}, {45, SHIFT, 30}, },
			{{-1, REDUCE, 37}, },
			{{-1, ERROR, 24}, {45, SHIFT, 15}, },
			{{-1, REDUCE, 12}, {26, SHIFT, 33}, {28, SHIFT, 34}, {30, SHIFT, 35}, },
			{{-1, REDUCE, 42}, {13, SHIFT, 37}, },
			{{-1, REDUCE, 42}, {13, SHIFT, 37}, },
			{{-1, ERROR, 28}, {4, SHIFT, 41}, {6, SHIFT, 42}, {7, SHIFT, 43}, {20, SHIFT, 44}, {45, SHIFT, 30}, {46, SHIFT, 45}, },
			{{-1, ERROR, 29}, {4, SHIFT, 50}, {6, SHIFT, 42}, {7, SHIFT, 43}, {20, SHIFT, 44}, {45, SHIFT, 30}, {46, SHIFT, 45}, },
			{{-1, REDUCE, 51}, {28, SHIFT, 51}, },
			{{-1, REDUCE, 50}, },
			{{-1, REDUCE, 49}, },
			{{-1, REDUCE, 7}, },
			{{-1, REDUCE, 7}, },
			{{-1, REDUCE, 13}, },
			{{-1, REDUCE, 4}, },
			{{-1, ERROR, 37}, {45, SHIFT, 54}, },
			{{-1, REDUCE, 39}, },
			{{-1, ERROR, 39}, {4, SHIFT, 55}, {45, SHIFT, 56}, },
			{{-1, ERROR, 40}, {4, SHIFT, 58}, {45, SHIFT, 56}, },
			{{-1, REDUCE, 16}, },
			{{-1, ERROR, 42}, {45, SHIFT, 59}, },
			{{-1, ERROR, 43}, {20, SHIFT, 44}, {45, SHIFT, 30}, {46, SHIFT, 45}, },
			{{-1, ERROR, 44}, {45, SHIFT, 30}, },
			{{-1, REDUCE, 29}, },
			{{-1, REDUCE, 19}, },
			{{-1, ERROR, 47}, {37, SHIFT, 63}, },
			{{-1, REDUCE, 14}, {34, SHIFT, 64}, {37, REDUCE, 26}, },
			{{-1, REDUCE, 27}, },
			{{-1, REDUCE, 17}, },
			{{-1, ERROR, 51}, {45, SHIFT, 30}, },
			{{-1, ERROR, 52}, {27, SHIFT, 68}, {44, SHIFT, 69}, {45, SHIFT, 70}, {46, SHIFT, 71}, },
			{{-1, ERROR, 53}, {29, SHIFT, 73}, {44, SHIFT, 69}, {45, SHIFT, 70}, {46, SHIFT, 71}, },
			{{-1, ERROR, 54}, {33, SHIFT, 74}, },
			{{-1, REDUCE, 34}, },
			{{-1, ERROR, 56}, {35, SHIFT, 75}, },
			{{-1, REDUCE, 43}, },
			{{-1, REDUCE, 35}, },
			{{-1, ERROR, 59}, {33, SHIFT, 76}, },
			{{-1, ERROR, 60}, {16, SHIFT, 77}, {37, SHIFT, 63}, },
			{{-1, REDUCE, 26}, },
			{{-1, ERROR, 62}, {20, SHIFT, 78}, },
			{{-1, ERROR, 63}, {45, SHIFT, 79}, },
			{{-1, REDUCE, 15}, },
			{{-1, REDUCE, 20}, },
			{{-1, REDUCE, 53}, },
			{{-1, ERROR, 67}, {29, SHIFT, 80}, {30, SHIFT, 81}, },
			{{-1, REDUCE, 12}, {30, SHIFT, 35}, },
			{{-1, REDUCE, 10}, },
			{{-1, REDUCE, 9}, },
			{{-1, REDUCE, 11}, },
			{{-1, REDUCE, 12}, {30, SHIFT, 35}, },
			{{-1, REDUCE, 12}, {30, SHIFT, 35}, },
			{{-1, ERROR, 74}, {45, SHIFT, 30}, },
			{{-1, ERROR, 75}, {14, SHIFT, 86}, },
			{{-1, ERROR, 76}, {20, SHIFT, 44}, {45, SHIFT, 30}, {46, SHIFT, 45}, },
			{{-1, REDUCE, 18}, },
			{{-1, ERROR, 78}, {45, SHIFT, 89}, },
			{{-1, ERROR, 79}, {28, SHIFT, 90}, },
			{{-1, REDUCE, 52}, },
			{{-1, ERROR, 81}, {45, SHIFT, 30}, },
			{{-1, REDUCE, 5}, },
			{{-1, REDUCE, 8}, },
			{{-1, REDUCE, 6}, },
			{{-1, REDUCE, 41}, {32, SHIFT, 92}, },
			{{-1, ERROR, 86}, {26, SHIFT, 93}, },
			{{-1, ERROR, 87}, {1, SHIFT, 94}, {37, SHIFT, 63}, },
			{{-1, REDUCE, 23}, {2, SHIFT, 95}, {3, SHIFT, 96}, {6, SHIFT, 42}, {7, SHIFT, 43}, {20, SHIFT, 44}, {45, SHIFT, 30}, {46, SHIFT, 45}, },
			{{-1, REDUCE, 28}, },
			{{-1, ERROR, 90}, {20, SHIFT, 44}, {29, SHIFT, 98}, {45, SHIFT, 30}, {46, SHIFT, 45}, },
			{{-1, REDUCE, 54}, },
			{{-1, ERROR, 92}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, REDUCE, 46}, {45, SHIFT, 15}, },
			{{-1, REDUCE, 18}, },
			{{-1, REDUCE, 18}, },
			{{-1, ERROR, 96}, {20, SHIFT, 44}, {45, SHIFT, 30}, {46, SHIFT, 45}, },
			{{-1, ERROR, 97}, {4, SHIFT, 127}, },
			{{-1, REDUCE, 30}, },
			{{-1, REDUCE, 32}, {37, SHIFT, 63}, },
			{{-1, ERROR, 100}, {29, SHIFT, 128}, {30, SHIFT, 129}, },
			{{-1, REDUCE, 125}, },
			{{-1, REDUCE, 127}, },
			{{-1, REDUCE, 126}, },
			{{-1, ERROR, 104}, {45, SHIFT, 30}, },
			{{-1, ERROR, 105}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {26, SHIFT, 107}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 106}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {26, SHIFT, 107}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 107}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 108}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {26, SHIFT, 107}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, REDUCE, 123}, },
			{{-1, REDUCE, 111}, },
			{{-1, REDUCE, 124}, },
			{{-1, REDUCE, 40}, },
			{{-1, REDUCE, 78}, {43, SHIFT, 136}, },
			{{-1, REDUCE, 79}, {42, SHIFT, 137}, },
			{{-1, REDUCE, 81}, },
			{{-1, REDUCE, 83}, {21, SHIFT, 138}, {22, SHIFT, 139}, {35, SHIFT, 140}, {36, SHIFT, 141}, {38, SHIFT, 142}, {39, SHIFT, 143}, {40, SHIFT, 144}, {41, SHIFT, 145}, },
			{{-1, REDUCE, 90}, {23, SHIFT, 146}, {24, SHIFT, 147}, {25, SHIFT, 148}, },
			{{-1, REDUCE, 93}, },
			{{-1, REDUCE, 97}, {28, SHIFT, 149}, {31, SHIFT, 150}, {37, SHIFT, 151}, },
			{{-1, REDUCE, 98}, {28, SHIFT, 152}, {31, SHIFT, 153}, {37, SHIFT, 154}, },
			{{-1, REDUCE, 112}, },
			{{-1, ERROR, 122}, {27, SHIFT, 155}, },
			{{-1, REDUCE, 47}, {30, SHIFT, 24}, },
			{{-1, ERROR, 124}, {4, SHIFT, 156}, {6, SHIFT, 42}, {7, SHIFT, 43}, {20, SHIFT, 44}, {45, SHIFT, 30}, {46, SHIFT, 45}, },
			{{-1, REDUCE, 24}, {6, SHIFT, 42}, {7, SHIFT, 43}, {20, SHIFT, 44}, {45, SHIFT, 30}, {46, SHIFT, 45}, },
			{{-1, ERROR, 126}, {16, SHIFT, 157}, {37, SHIFT, 63}, },
			{{-1, REDUCE, 14}, {34, SHIFT, 64}, },
			{{-1, REDUCE, 31}, },
			{{-1, ERROR, 129}, {20, SHIFT, 44}, {45, SHIFT, 30}, {46, SHIFT, 45}, },
			{{-1, ERROR, 130}, {20, SHIFT, 160}, },
			{{-1, REDUCE, 100}, {28, SHIFT, 149}, {31, SHIFT, 150}, {37, SHIFT, 151}, },
			{{-1, ERROR, 132}, {28, SHIFT, 152}, {31, SHIFT, 153}, {37, SHIFT, 154}, },
			{{-1, REDUCE, 99}, {28, SHIFT, 149}, {31, SHIFT, 150}, {37, SHIFT, 151}, },
			{{-1, ERROR, 134}, {27, SHIFT, 161}, },
			{{-1, REDUCE, 101}, {28, SHIFT, 149}, {31, SHIFT, 150}, {37, SHIFT, 151}, },
			{{-1, ERROR, 136}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 137}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 138}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 139}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 140}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 141}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 142}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 143}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 144}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 145}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 146}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 147}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 148}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 149}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 150}, {45, SHIFT, 176}, },
			{{-1, ERROR, 151}, {45, SHIFT, 177}, },
			{{-1, ERROR, 152}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 153}, {45, SHIFT, 179}, },
			{{-1, ERROR, 154}, {45, SHIFT, 180}, },
			{{-1, REDUCE, 3}, {33, SHIFT, 181}, },
			{{-1, REDUCE, 14}, {34, SHIFT, 64}, },
			{{-1, REDUCE, 18}, },
			{{-1, REDUCE, 22}, },
			{{-1, REDUCE, 33}, {37, SHIFT, 63}, },
			{{-1, ERROR, 160}, {45, SHIFT, 185}, },
			{{-1, REDUCE, 115}, },
			{{-1, REDUCE, 80}, {42, SHIFT, 137}, },
			{{-1, REDUCE, 82}, },
			{{-1, REDUCE, 91}, {23, SHIFT, 146}, {24, SHIFT, 147}, {25, SHIFT, 148}, },
			{{-1, REDUCE, 92}, {23, SHIFT, 146}, {24, SHIFT, 147}, {25, SHIFT, 148}, },
			{{-1, REDUCE, 84}, {21, SHIFT, 138}, {22, SHIFT, 139}, },
			{{-1, REDUCE, 85}, {21, SHIFT, 138}, {22, SHIFT, 139}, },
			{{-1, REDUCE, 88}, {21, SHIFT, 138}, {22, SHIFT, 139}, },
			{{-1, REDUCE, 86}, {21, SHIFT, 138}, {22, SHIFT, 139}, },
			{{-1, REDUCE, 89}, {21, SHIFT, 138}, {22, SHIFT, 139}, },
			{{-1, REDUCE, 87}, {21, SHIFT, 138}, {22, SHIFT, 139}, },
			{{-1, REDUCE, 94}, },
			{{-1, REDUCE, 95}, },
			{{-1, REDUCE, 96}, },
			{{-1, ERROR, 175}, {29, SHIFT, 186}, },
			{{-1, REDUCE, 109}, },
			{{-1, ERROR, 177}, {26, SHIFT, 187}, },
			{{-1, ERROR, 178}, {29, SHIFT, 189}, },
			{{-1, REDUCE, 113}, },
			{{-1, ERROR, 180}, {26, SHIFT, 187}, },
			{{-1, ERROR, 181}, {45, SHIFT, 30}, },
			{{-1, REDUCE, 57}, {19, SHIFT, 25}, },
			{{-1, REDUCE, 21}, },
			{{-1, REDUCE, 23}, {2, SHIFT, 95}, {3, SHIFT, 96}, {6, SHIFT, 42}, {7, SHIFT, 43}, {20, SHIFT, 44}, {45, SHIFT, 30}, {46, SHIFT, 45}, },
			{{-1, ERROR, 185}, {26, SHIFT, 187}, },
			{{-1, REDUCE, 110}, },
			{{-1, ERROR, 187}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {27, SHIFT, 195}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, REDUCE, 108}, },
			{{-1, REDUCE, 114}, },
			{{-1, REDUCE, 107}, },
			{{-1, REDUCE, 3}, },
			{{-1, ERROR, 192}, {4, SHIFT, 199}, {5, SHIFT, 101}, {7, SHIFT, 200}, {12, SHIFT, 102}, {13, SHIFT, 37}, {15, SHIFT, 201}, {17, SHIFT, 103}, {18, SHIFT, 202}, {20, SHIFT, 203}, {44, SHIFT, 109}, {45, SHIFT, 204}, {46, SHIFT, 111}, },
			{{-1, REDUCE, 25}, },
			{{-1, REDUCE, 106}, },
			{{-1, REDUCE, 102}, },
			{{-1, REDUCE, 104}, },
			{{-1, ERROR, 197}, {27, SHIFT, 211}, {30, SHIFT, 212}, },
			{{-1, REDUCE, 55}, {19, SHIFT, 25}, },
			{{-1, REDUCE, 45}, },
			{{-1, ERROR, 200}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, REDUCE, 67}, },
			{{-1, ERROR, 202}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 203}, {45, SHIFT, 30}, },
			{{-1, REDUCE, 119}, {32, SHIFT, 217}, },
			{{-1, REDUCE, 73}, },
			{{-1, REDUCE, 14}, {34, SHIFT, 64}, },
			{{-1, REDUCE, 66}, },
			{{-1, REDUCE, 77}, {37, SHIFT, 219}, },
			{{-1, ERROR, 209}, {28, SHIFT, 220}, {31, SHIFT, 221}, {37, SHIFT, 222}, },
			{{-1, REDUCE, 120}, },
			{{-1, REDUCE, 103}, },
			{{-1, ERROR, 212}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 213}, {4, SHIFT, 224}, {5, SHIFT, 101}, {7, SHIFT, 225}, {12, SHIFT, 102}, {13, SHIFT, 37}, {15, SHIFT, 226}, {17, SHIFT, 103}, {18, SHIFT, 227}, {20, SHIFT, 203}, {44, SHIFT, 109}, {45, SHIFT, 204}, {46, SHIFT, 111}, },
			{{-1, ERROR, 214}, {16, SHIFT, 230}, },
			{{-1, ERROR, 215}, {1, SHIFT, 231}, },
			{{-1, ERROR, 216}, {20, SHIFT, 232}, },
			{{-1, ERROR, 217}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, REDUCE, 58}, },
			{{-1, ERROR, 219}, {45, SHIFT, 234}, },
			{{-1, ERROR, 220}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 221}, {45, SHIFT, 236}, },
			{{-1, ERROR, 222}, {45, SHIFT, 237}, },
			{{-1, REDUCE, 105}, },
			{{-1, REDUCE, 44}, },
			{{-1, ERROR, 225}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 226}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 227}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, REDUCE, 14}, {34, SHIFT, 64}, },
			{{-1, REDUCE, 59}, },
			{{-1, REDUCE, 57}, },
			{{-1, REDUCE, 57}, },
			{{-1, ERROR, 232}, {45, SHIFT, 244}, },
			{{-1, REDUCE, 74}, },
			{{-1, ERROR, 234}, {26, SHIFT, 187}, },
			{{-1, ERROR, 235}, {29, SHIFT, 246}, },
			{{-1, REDUCE, 121}, {32, SHIFT, 247}, },
			{{-1, ERROR, 237}, {26, SHIFT, 187}, },
			{{-1, ERROR, 238}, {16, SHIFT, 249}, },
			{{-1, REDUCE, 60}, },
			{{-1, ERROR, 240}, {1, SHIFT, 250}, },
			{{-1, REDUCE, 56}, },
			{{-1, REDUCE, 70}, {2, SHIFT, 251}, {3, SHIFT, 252}, {5, SHIFT, 101}, {7, SHIFT, 200}, {12, SHIFT, 102}, {13, SHIFT, 37}, {15, SHIFT, 201}, {17, SHIFT, 103}, {18, SHIFT, 202}, {20, SHIFT, 203}, {44, SHIFT, 109}, {45, SHIFT, 204}, {46, SHIFT, 111}, },
			{{-1, ERROR, 243}, {4, SHIFT, 254}, {5, SHIFT, 101}, {7, SHIFT, 200}, {12, SHIFT, 102}, {13, SHIFT, 37}, {15, SHIFT, 201}, {17, SHIFT, 103}, {18, SHIFT, 202}, {20, SHIFT, 203}, {44, SHIFT, 109}, {45, SHIFT, 204}, {46, SHIFT, 111}, },
			{{-1, ERROR, 244}, {26, SHIFT, 187}, },
			{{-1, REDUCE, 118}, },
			{{-1, REDUCE, 122}, {32, SHIFT, 256}, },
			{{-1, ERROR, 247}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, REDUCE, 117}, },
			{{-1, REDUCE, 55}, },
			{{-1, REDUCE, 55}, },
			{{-1, REDUCE, 57}, },
			{{-1, ERROR, 252}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 253}, {4, SHIFT, 262}, },
			{{-1, REDUCE, 68}, },
			{{-1, REDUCE, 116}, },
			{{-1, ERROR, 256}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, REDUCE, 76}, },
			{{-1, REDUCE, 63}, {2, SHIFT, 264}, {3, SHIFT, 265}, {5, SHIFT, 101}, {7, SHIFT, 225}, {12, SHIFT, 102}, {13, SHIFT, 37}, {15, SHIFT, 226}, {17, SHIFT, 103}, {18, SHIFT, 227}, {20, SHIFT, 203}, {44, SHIFT, 109}, {45, SHIFT, 204}, {46, SHIFT, 111}, },
			{{-1, ERROR, 259}, {4, SHIFT, 267}, {5, SHIFT, 101}, {7, SHIFT, 225}, {12, SHIFT, 102}, {13, SHIFT, 37}, {15, SHIFT, 226}, {17, SHIFT, 103}, {18, SHIFT, 227}, {20, SHIFT, 203}, {44, SHIFT, 109}, {45, SHIFT, 204}, {46, SHIFT, 111}, },
			{{-1, REDUCE, 71}, {5, SHIFT, 101}, {7, SHIFT, 200}, {12, SHIFT, 102}, {13, SHIFT, 37}, {15, SHIFT, 201}, {17, SHIFT, 103}, {18, SHIFT, 202}, {20, SHIFT, 203}, {44, SHIFT, 109}, {45, SHIFT, 204}, {46, SHIFT, 111}, },
			{{-1, ERROR, 261}, {16, SHIFT, 268}, },
			{{-1, REDUCE, 69}, },
			{{-1, REDUCE, 75}, },
			{{-1, REDUCE, 55}, },
			{{-1, ERROR, 265}, {5, SHIFT, 101}, {12, SHIFT, 102}, {17, SHIFT, 103}, {20, SHIFT, 104}, {21, SHIFT, 105}, {22, SHIFT, 106}, {26, SHIFT, 107}, {37, SHIFT, 108}, {44, SHIFT, 109}, {45, SHIFT, 110}, {46, SHIFT, 111}, },
			{{-1, ERROR, 266}, {4, SHIFT, 271}, },
			{{-1, REDUCE, 61}, },
			{{-1, REDUCE, 57}, },
			{{-1, REDUCE, 64}, {5, SHIFT, 101}, {7, SHIFT, 225}, {12, SHIFT, 102}, {13, SHIFT, 37}, {15, SHIFT, 226}, {17, SHIFT, 103}, {18, SHIFT, 227}, {20, SHIFT, 203}, {44, SHIFT, 109}, {45, SHIFT, 204}, {46, SHIFT, 111}, },
			{{-1, ERROR, 270}, {16, SHIFT, 273}, },
			{{-1, REDUCE, 62}, },
			{{-1, REDUCE, 70}, {2, SHIFT, 251}, {3, SHIFT, 252}, {5, SHIFT, 101}, {7, SHIFT, 200}, {12, SHIFT, 102}, {13, SHIFT, 37}, {15, SHIFT, 201}, {17, SHIFT, 103}, {18, SHIFT, 202}, {20, SHIFT, 203}, {44, SHIFT, 109}, {45, SHIFT, 204}, {46, SHIFT, 111}, },
			{{-1, REDUCE, 55}, },
			{{-1, REDUCE, 72}, },
			{{-1, REDUCE, 63}, {2, SHIFT, 264}, {3, SHIFT, 265}, {5, SHIFT, 101}, {7, SHIFT, 225}, {12, SHIFT, 102}, {13, SHIFT, 37}, {15, SHIFT, 226}, {17, SHIFT, 103}, {18, SHIFT, 227}, {20, SHIFT, 203}, {44, SHIFT, 109}, {45, SHIFT, 204}, {46, SHIFT, 111}, },
			{{-1, REDUCE, 65}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 1}, },
			{{-1, 18}, {12, 19}, {13, 20}, {14, 21}, {155, 182}, {191, 198}, },
			{{-1, 52}, {34, 53}, },
			{{-1, 72}, },
			{{-1, 36}, {68, 82}, {72, 83}, {73, 84}, },
			{{-1, 65}, {127, 158}, {156, 183}, {206, 218}, {228, 241}, },
			{{-1, 3}, },
			{{-1, 28}, {21, 29}, {77, 88}, {94, 124}, {95, 125}, {157, 184}, },
			{{-1, 46}, },
			{{-1, 97}, {184, 193}, },
			{{-1, 47}, {43, 60}, {76, 87}, {90, 99}, {96, 126}, {129, 159}, },
			{{-1, 48}, {43, 61}, {76, 61}, {90, 61}, {96, 61}, {129, 61}, },
			{{-1, 100}, },
			{{-1, 4}, },
			{{-1, 11}, {7, 12}, {8, 13}, {9, 14}, },
			{{-1, 26}, {19, 27}, },
			{{-1, 205}, {26, 38}, {27, 38}, },
			{{-1, 39}, {27, 40}, },
			{{-1, 57}, },
			{{-1, 122}, },
			{{-1, 16}, {93, 123}, },
			{{-1, 17}, {24, 32}, },
			{{-1, 49}, {22, 31}, {44, 62}, {51, 66}, {74, 85}, {81, 91}, {104, 130}, {181, 191}, {203, 216}, },
			{{-1, 67}, },
			{{-1, 213}, {249, 258}, {250, 259}, {264, 269}, {273, 275}, },
			{{-1, 192}, {230, 242}, {231, 243}, {251, 260}, {268, 272}, },
			{{-1, 228}, },
			{{-1, 266}, {275, 276}, },
			{{-1, 206}, },
			{{-1, 253}, {272, 274}, },
			{{-1, 207}, {213, 229}, {258, 229}, {259, 229}, {269, 229}, {275, 229}, },
			{{-1, 112}, {107, 134}, {149, 175}, {152, 178}, {187, 196}, {200, 214}, {202, 215}, {212, 223}, {217, 233}, {220, 235}, {225, 238}, {226, 239}, {227, 240}, {247, 257}, {252, 261}, {256, 263}, {265, 270}, },
			{{-1, 113}, },
			{{-1, 114}, {136, 162}, },
			{{-1, 115}, {137, 163}, },
			{{-1, 116}, {140, 166}, {141, 167}, {142, 168}, {143, 169}, {144, 170}, {145, 171}, },
			{{-1, 117}, {138, 164}, {139, 165}, },
			{{-1, 118}, {146, 172}, {147, 173}, {148, 174}, },
			{{-1, 188}, {180, 190}, {185, 194}, {234, 245}, {237, 248}, {244, 255}, },
			{{-1, 197}, },
			{{-1, 119}, {105, 131}, {106, 133}, {108, 135}, },
			{{-1, 120}, {105, 132}, {106, 132}, {108, 132}, },
			{{-1, 208}, },
			{{-1, 209}, },
			{{-1, 121}, {192, 210}, {213, 210}, {242, 210}, {243, 210}, {258, 210}, {259, 210}, {260, 210}, {269, 210}, {272, 210}, {275, 210}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: ident, EOF",
			"expecting: '='",
			"expecting: 'cluster', 'interface', 'metacluster', 'metaproc'",
			"expecting: 'end', 'var', atidn, '[', ident",
			"expecting: 'end', 'for', 'if', atidn, '$', '[', ident, string",
			"expecting: ident",
			"expecting: 'end', 'var', atidn, ident",
			"expecting: 'end', 'for', 'if', atidn, '$', ident, string",
			"expecting: ':'",
			"expecting: ']', ','",
			"expecting: ')', ']', ','",
			"expecting: 'end', 'for', 'if', 'var', atidn, '$', ident, string",
			"expecting: 'end', 'false', 'for', 'if', 'nil', 'var', 'return', 'true', 'while', atidn, '$', '(', '[', ',', iconst, ident, string",
			"expecting: 'end', 'var', ident",
			"expecting: 'end', 'for', 'if', '$', ident, string",
			"expecting: 'do', 'else', 'elsif', 'end', 'false', 'if', 'nil', 'var', 'return', 'then', 'true', 'while', atidn, '$', ')', '[', ']', ',', ':=', ';', '!', iconst, ident, string",
			"expecting: ')', iconst, ident, string",
			"expecting: ']', iconst, ident, string",
			"expecting: 'end', 'false', 'for', 'if', 'nil', 'var', 'return', 'true', 'while', atidn, '$', ')', ']', iconst, ident, string",
			"expecting: 'end', 'false', 'for', 'if', 'nil', 'var', 'return', 'true', 'while', atidn, '$', iconst, ident, string",
			"expecting: 'end', ident",
			"expecting: '$', ident, string",
			"expecting: 'do', 'then', ']', ',', '!'",
			"expecting: 'else', 'elsif', 'end', 'for', 'if', '$', ident, string",
			"expecting: '!'",
			"expecting: 'else', 'elsif', 'end', 'for', 'if', '$', ';', '!', ident, string",
			"expecting: 'then', '!'",
			"expecting: '$'",
			"expecting: 'else', 'elsif', 'end', 'false', 'for', 'if', 'nil', 'var', 'return', 'true', 'while', '$', iconst, ident, string",
			"expecting: 'end', 'false', 'for', 'if', 'nil', 'var', 'return', 'true', 'while', atidn, '$', ',', iconst, ident, string",
			"expecting: ')', ']', ',', iconst, ident, string",
			"expecting: 'proc'",
			"expecting: '['",
			"expecting: 'do', 'else', 'elsif', 'end', 'false', 'if', 'nil', 'var', 'return', 'then', 'true', 'while', atidn, '$', ')', ']', ',', ':=', ';', '!', iconst, ident, string",
			"expecting: ')', ']', iconst, ident, string",
			"expecting: 'else', 'elsif', 'end', 'false', 'if', 'nil', 'var', 'return', 'true', 'while', '$', ':=', ';', iconst, ident, string",
			"expecting: '('",
			"expecting: 'do', '!'",
			"expecting: '$', ']', ident, string",
			"expecting: 'false', 'nil', 'true', '$', '+', '-', '(', '!', iconst, ident, string",
			"expecting: ')', ident",
			"expecting: 'end'",
			"expecting: 'do', 'else', 'elsif', 'end', 'for', 'if', 'then', '$', ']', ',', ';', '!', ident, string",
			"expecting: ']', ',', '!'",
			"expecting: 'do', 'else', 'elsif', 'end', 'false', 'if', 'nil', 'var', 'return', 'then', 'true', 'while', '$', '+', '-', '*', '/', '%', ')', '[', ']', ',', '.', ';', '=', '!=', '!', '<=', '<', '>=', '>', '&&', '||', iconst, ident, string",
			"expecting: 'false', 'nil', 'true', '$', '(', iconst, ident, string",
			"expecting: 'else', 'elsif', 'end', 'false', 'if', 'nil', 'var', 'return', 'true', 'while', '$', ';', iconst, ident, string",
			"expecting: 'do', 'else', 'elsif', 'end', 'false', 'if', 'nil', 'var', 'return', 'then', 'true', 'while', '$', ')', ']', ',', ';', '||', iconst, ident, string",
			"expecting: 'do', 'else', 'elsif', 'end', 'false', 'if', 'nil', 'var', 'return', 'then', 'true', 'while', '$', ')', ']', ',', ';', '&&', '||', iconst, ident, string",
			"expecting: 'do', 'else', 'elsif', 'end', 'false', 'if', 'nil', 'var', 'return', 'then', 'true', 'while', '$', '+', '-', ')', ']', ',', ';', '=', '!=', '<=', '<', '>=', '>', '&&', '||', iconst, ident, string",
			"expecting: 'do', 'else', 'elsif', 'end', 'false', 'if', 'nil', 'var', 'return', 'then', 'true', 'while', '$', '+', '-', '*', '/', '%', ')', ']', ',', ';', '=', '!=', '<=', '<', '>=', '>', '&&', '||', iconst, ident, string",
			"expecting: ')'",
			"expecting: ')', ','",
			"expecting: 'else', 'elsif', 'end', 'for', 'if', '$', ';', ident, string",
			"expecting: '[', '.', '!'",
			"expecting: 'end', 'false', 'if', 'nil', 'var', 'return', 'true', 'while', atidn, '$', ':', iconst, ident, string",
			"expecting: 'do', 'else', 'elsif', 'end', 'false', 'if', 'nil', 'var', 'return', 'then', 'true', 'while', '$', '+', '-', ')', ']', ',', ';', '&&', '||', iconst, ident, string",
			"expecting: ']'",
			"expecting: 'end', 'false', 'if', 'nil', 'var', 'return', 'true', 'while', atidn, '$', iconst, ident, string",
			"expecting: 'false', 'nil', 'true', '$', '+', '-', '(', ')', '!', iconst, ident, string",
			"expecting: 'end', 'false', 'if', 'nil', 'var', 'return', 'true', 'while', '$', iconst, ident, string",
			"expecting: '[', '.', ':=', '!'",
			"expecting: 'else', 'elsif', 'end', 'false', 'if', 'nil', 'var', 'return', 'true', 'while', '$', ';', '!', iconst, ident, string",
			"expecting: 'then'",
			"expecting: 'do'",
			"expecting: 'else', 'elsif', 'end', 'false', 'if', 'nil', 'var', 'return', 'true', 'while', '$', iconst, ident, string",
        };*/
    private static int[] errors;
/*      {
			0, 0, 1, 0, 0, 2, 3, 3, 4, 4, 5, 6, 6, 7, 7, 8, 9, 10, 6, 6, 7, 7, 5, 11, 5, 12, 13, 13, 14, 14, 15, 10, 10, 16, 17, 18, 19, 5, 13, 20, 20, 0, 5, 21, 5, 22, 23, 24, 25, 22, 0, 5, 16, 17, 8, 0, 1, 20, 0, 8, 26, 22, 27, 5, 28, 23, 9, 9, 29, 30, 30, 30, 30, 29, 5, 31, 21, 23, 5, 32, 33, 5, 19, 34, 19, 35, 36, 37, 23, 22, 38, 9, 39, 40, 14, 14, 21, 41, 42, 43, 9, 44, 44, 44, 5, 45, 45, 39, 45, 44, 44, 44, 46, 47, 48, 48, 49, 50, 50, 44, 44, 44, 51, 52, 14, 14, 26, 53, 42, 21, 27, 44, 54, 44, 51, 44, 39, 39, 39, 39, 39, 39, 39, 39, 39, 39, 39, 39, 39, 39, 5, 5, 39, 5, 5, 55, 53, 23, 23, 43, 5, 44, 48, 48, 50, 50, 56, 56, 56, 56, 56, 56, 50, 50, 50, 57, 44, 36, 57, 44, 36, 5, 58, 23, 23, 36, 44, 59, 44, 44, 44, 58, 60, 41, 44, 44, 52, 52, 58, 20, 39, 46, 39, 5, 61, 46, 46, 46, 62, 54, 54, 44, 39, 60, 63, 64, 27, 39, 65, 5, 39, 5, 5, 52, 20, 39, 39, 39, 46, 46, 65, 60, 5, 46, 36, 57, 61, 36, 63, 46, 64, 65, 65, 60, 36, 62, 61, 39, 62, 65, 60, 60, 39, 41, 46, 62, 39, 46, 65, 60, 60, 63, 46, 46, 60, 39, 41, 46, 65, 60, 63, 46, 65, 65, 41, 65, 41, 
        };*/

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Parser.class.getResourceAsStream("parser.dat")));

            // read actionTable
            int length = s.readInt();
            Parser.actionTable = new int[length][][];
            for(int i = 0; i < Parser.actionTable.length; i++)
            {
                length = s.readInt();
                Parser.actionTable[i] = new int[length][3];
                for(int j = 0; j < Parser.actionTable[i].length; j++)
                {
                for(int k = 0; k < 3; k++)
                {
                    Parser.actionTable[i][j][k] = s.readInt();
                }
                }
            }

            // read gotoTable
            length = s.readInt();
            gotoTable = new int[length][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][2];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                for(int k = 0; k < 2; k++)
                {
                    gotoTable[i][j][k] = s.readInt();
                }
                }
            }

            // read errorMessages
            length = s.readInt();
            errorMessages = new String[length];
            for(int i = 0; i < errorMessages.length; i++)
            {
                length = s.readInt();
                StringBuffer buffer = new StringBuffer();

                for(int j = 0; j < length; j++)
                {
                buffer.append(s.readChar());
                }
                errorMessages[i] = buffer.toString();
            }

            // read errors
            length = s.readInt();
            errors = new int[length];
            for(int i = 0; i < errors.length; i++)
            {
                errors[i] = s.readInt();
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
        }
    }
}
